#include "desk.h"
#include "card.h"
#include "coloda.h"
#include "player.h"
#include "plscore.h"
#include "locale.h"
#include <stdio.h>

// for sleep
#ifdef __BORLANDC__
#include "WinPrefMain_u.h"
#ifdef PRFDEBUG
#include <dos.h>
#include <stdlib.h>
#endif
#endif

#ifdef __GNUC__
#ifdef PRFDEBUG
#include <unistd.h> //???
#include <stdlib.h>
#endif
#endif
//----------------------------------------------------------------------
TDesk::TDesk() {
   AColoda = new TColoda(CARDINCOLODA);
   AColoda -> Mix();
   Pl[0]=NULL;
   Pl[1] = new  TPlayer();
   Pl[1] -> nPlayer = 1;
   #ifdef __BORLANDC__
     Pl[1] -> aPanel = FormMain->Panel1;
   #endif
   Pl[2] = new TPlayer();
   Pl[2]->nPlayer = 2;
   #ifdef __BORLANDC__
     Pl[2] -> aPanel = FormMain->Panel2;
   #endif
   Pl[3] = new TPlayer();
   Pl[3]->nPlayer = 3;
   #ifdef __BORLANDC__
     Pl[3] -> aPanel = FormMain->Panel3;
   #endif
   Paper = new TPaper();
   firstmove = 1; //   
}
//----------------------------------------------------------------------
TDesk::~TDesk() {
    delete Paper;
    delete Pl[1];
    delete Pl[2];
    delete Pl[3];
    delete AColoda;
}
//----------------------------------------------------------------------
Tgamestype TDesk::Torg(void) {
     Tgamestype plrv[4];
     Tgamestype gmax=pass;
     Tgamestype OtherVist=undefined;
     Tncounter  plcounter(1,1,3);
     int ncurrpl =firstmove;
     int npl=0; //  ,  
     ngamer=0;
     plrv[1]=Pl[1]->typegame =undefined;
     plrv[2]=Pl[2]->typegame =undefined;
     plrv[3]=Pl[3]->typegame =undefined;
     ClearInfo();
     while ( !((plrv[1]==pass && plrv[2]==pass ) || (plrv[2]==pass && plrv[3]==pass ) || (plrv[3]==pass && plrv[1]==pass )) ) {
        for (int i=1;i<=3;i++) {
            Tgamestype oldgame = plrv[ncurrpl];
            if (plrv[ncurrpl] != pass)
               plrv[ncurrpl]=Pl[ncurrpl]->nTorg(gmax,ncurrpl,firstmove);
            if (plrv[ncurrpl] > gmax) {
               gmax=plrv[ncurrpl];
               npl =ncurrpl;
            }
            #ifdef __BORLANDC__
               if (oldgame == undefined || plrv[ncurrpl] != pass) {
                  if (ncurrpl==1) FormMain->p1LabelGame->Caption = pcCameName(plrv[ncurrpl]);
                  if (ncurrpl==2) FormMain->p2LabelGame->Caption = pcCameName(plrv[ncurrpl]);
                  if (ncurrpl==3) FormMain->p3LabelGame->Caption = pcCameName(plrv[ncurrpl]);
                  sprintf(mess,"%s",pcCameName(plrv[ncurrpl]));
                  FormMain->SayCurrentGame(mess,ncurrpl);
               } else {
                  if (ncurrpl==1) FormMain->p1LabelGame->Caption = pcCameName(plrv[ncurrpl]);
                  if (ncurrpl==2) FormMain->p2LabelGame->Caption = pcCameName(plrv[ncurrpl]);
                  if (ncurrpl==3) FormMain->p3LabelGame->Caption = pcCameName(plrv[ncurrpl]);
                  Application->ProcessMessages();
                  Sleep(400);
               }
            #endif
            ncurrpl++;
            if (ncurrpl==4)
              ncurrpl=1;
        }
     }
     if (gmax != pass || gmax==g96) {
          TCard *c30=(TCard *)AColoda->At(30),*c31=(TCard *)AColoda->At(31);
          #ifdef __BORLANDC__
             ShowPrikup(c30,c31);
          #endif
          Pl[npl]->aCards->Insert(c30);
          Pl[npl]->aCards->Insert(c31);
          #ifdef __BORLANDC__
            Pl[npl]->DrawCards(1);
          #endif
          FormMain->Repaint();
          //Application->ProcessMessages();
          ngamer = npl;
          if ( gmax==g96 ) {
             //Pl[npl] -> makeout4miser(firstmove); //      ,  
             //Pl[npl] -> maxgame(firstmove);
             //gmax = g96;
          } else {
             Pl[npl] -> makeout(firstmove); //      ,  
             Pl[npl] -> maxgame(firstmove);
             gmax = Pl[npl] -> SayGame(gmax);
          }
          #ifdef __BORLANDC__
            Pl[npl]->DrawCards(1);
            sprintf(mess," %s",pcCameName2(gmax),ngamer);
            FormMain->SayCurrentGame(mess,ngamer);
          #endif
          // m " 
          plcounter.nValue = ngamer;

          for ( int j =1;j<=2;j++ ) {
             ++plcounter;
             Pl[plcounter.nValue] -> mymast = Pl[npl]->mymast;
             Pl[plcounter.nValue] -> maxgame4vist(gmax,OtherVist);
             OtherVist =Pl[plcounter.nValue] -> typegame;
             RedrawPlayers();

             #ifdef __BORLANDC__
               sprintf(mess,"%s",pcCameName(Pl[plcounter.nValue] -> typegame),plcounter.nValue);
               FormMain->SayCurrentGame(mess,plcounter.nValue);
             #endif
          }
          RedrawPlayers();
     }
     if (gmax == pass) {
       //raspass
        for ( int j =1;j<=2;j++ ) {
             Pl[j] -> mymast = 5;
             Pl[j] -> typegame = raspass;
        }
        #ifdef __BORLANDC__
           sprintf(mess,"");
           FormMain->SayCurrentGame(mess,0);
        #endif
     }
     return gmax;
}
//----------------------------------------------------------------------
void TDesk::NewGame(void) {
   int i;
   Tncounter nPlayer(1,1,3);
   Pl[1]->CleanAll();
   Pl[2]->CleanAll();
   Pl[3]->CleanAll();
   for ( i=0;i<(CARDINCOLODA-2);i++ ) {
      Pl[nPlayer.nValue]->aCards->Insert(AColoda->At(i));
      ++nPlayer;
   }
   nGame=pass;
   #ifdef __BORLANDC__
   for (i=1;i<=3;i++)
       Pl[i]->DrawCards(1);
   #endif
}
//----------------------------------------------------------------------

void TDesk::RescanPlayersCard(void) {
    for ( int i=1;i<=3;i++ ) {
       switch ( i )     {
          case 1: {
            Pl[1]->aLeft->Assign(Pl[2]->aCards);
            Pl[1]->aRight->Assign(Pl[3]->aCards);
            break;
          }
          case 2: {
            Pl[2]->aLeft->Assign(Pl[3]->aCards);
            Pl[2]->aRight->Assign(Pl[1]->aCards);
          }
          case 3: {
            Pl[3]->aLeft->Assign(Pl[1]->aCards);
            Pl[3]->aRight->Assign(Pl[2]->aCards);
          }
       }
    }
}
//----------------------------------------------------------------------
void TDesk::RunGame(void) { //   
    int i,k,nAllvists=0,npasscard=0;
    int nPlCurrMove=firstmove;
    int nPl1,nPl2,nPl3;
    int PlVz=0;
    int dropgame=0;
    for (i=1;i<=3;i++) {
       if (i!=ngamer) {
         if (Pl[i] -> typegame == pass ) {
            dropgame += 2;
         }
         if (Pl[i] -> typegame == halfvist ) {
            dropgame += 1;
         }
       }
    }
    for (i = 1 ;i<=3;i++ ) {
      if (i != ngamer ) {
         if ( i==2 && ngamer==1 ) { Pl[i]->enemy=RIGHT;  }
         if ( i==3 && ngamer==1 ) { Pl[i]->enemy=LEFT;  }
         if ( i==3 && ngamer==2 ) { Pl[i]->enemy=RIGHT;  }
         if ( i==1 && ngamer==2 ) { Pl[i]->enemy=LEFT;  }
         if ( i==1 && ngamer==3 ) { Pl[i]->enemy=RIGHT;  }
         if ( i==2 && ngamer==3 ) { Pl[i]->enemy=LEFT;  }
//         Pl[i] -> typegame = vist;
      }
    }
    RescanPlayersCard();
/*    #ifdef __BORLANDC__
      ClearInfo();
    #endif*/

    if ( (dropgame !=3 && dropgame !=4) || nGame == pass) {
       for ( i=1;i<=10;i++ ) {
         Card[1]=NULL;
         Card[2]=NULL;
         Card[3]=NULL;
         KeyPress=0;
         nPl1=nPlCurrMove;
         #ifdef __BORLANDC__
           Sleep(500);
         #endif
         if ( nGame == pass && npasscard<2) {
            TCard *tmpprikup = (TCard *)AColoda->At(30+npasscard);
            TCard *tmp = new TCard(6,tmpprikup->CMast);
            npasscard++;
            ShowPrikup(tmpprikup,NULL);
            Card[nPlCurrMove]=Pl[nPlCurrMove]->makemove(NULL,tmp);
         } else {
            Card[nPlCurrMove]=Pl[nPlCurrMove]->makemove(NULL,NULL);
         }
         AfterPlMove(nPlCurrMove);
         nPl2=nPlCurrMove;
         #ifdef __BORLANDC__
           Sleep(500);
         #endif
         Card[nPlCurrMove]=Pl[nPlCurrMove]->makemove(NULL,Card[nPl1]);
         AfterPlMove(nPlCurrMove);
         nPl3=nPlCurrMove;
         #ifdef __BORLANDC__
           Sleep(500);
         #endif

         Card[nPlCurrMove]=Pl[nPlCurrMove]->makemove(Card[nPl1],Card[nPl2]);
         AfterPlMove(nPlCurrMove);
         #ifdef __BORLANDC__
           while ( !KeyPress ) {
              Application->ProcessMessages();
           }
           Beep();
         #endif
         PlVz = nPlayerTakeCards(Card[nPl1],Card[nPl2],Card[nPl3],Pl[1]->mymast); // 
         Card[nPl1] -> aCardImage ->Visible = false;
         Card[nPl2] -> aCardImage ->Visible = false;
         Card[nPl3] -> aCardImage ->Visible = false;
         //    
         switch ( PlVz )  {
            case 1: {  Pl[nPl1]->currvz++; nPlCurrMove=nPl1;  break;  }
            case 2: {  Pl[nPl2]->currvz++; nPlCurrMove=nPl2;  break;   }
            case 3: {  Pl[nPl3]->currvz++; nPlCurrMove=nPl3;  break;   }
         }
         RedrawPlayers();
       }  // end for
    }

    firstmove++;
    if (firstmove==4) firstmove=1;
    //   
    for (k = 1 ;k<=3; k++ )
       if (k !=ngamer)
          nAllvists += Pl[k]->currvz;
    for (k = 1 ; k<=3 ;k++ ) {
       if ( k == ngamer ) {
          Paper -> AddScore(ngamer,nGame,Pl[ngamer]->currvz);
       }
       else {
          if ( Pl[k]->typegame != pass ) {
             if ((ngamer == 1 && k == 2) || (ngamer == 2 && k == 3)||(ngamer == 3 && k == 1)) {
                Paper -> AddVist(k,nGame,Pl[ngamer]->currvz,Pl[k]->currvz,nAllvists,RIGHT);
             } else {
               Paper -> AddVist(k,nGame,Pl[ngamer]->currvz,Pl[k]->currvz,nAllvists,LEFT);
             }
          }
       }
    }

    #ifdef __BORLANDC__
//    ClearInfo();
    #endif

}
//----------------------------------------------------------------------
void TDesk::AfterPlMove(int &nPlayer) {
      RescanPlayersCard();
      #ifdef __BORLANDC__
      if ( nPlayer ==1 ) {
           MoveCardImage(Card[nPlayer] -> aCardImage ,FormMain->DesktopWidth / 2 - Card[nPlayer] -> aCardImage -> Width*1.25,FormMain->DesktopHeight / 2 );
      }
      if ( nPlayer ==2 ) {
         MoveCardImage(Card[nPlayer] -> aCardImage ,FormMain->DesktopWidth / 2 - (Card[nPlayer] -> aCardImage -> Width*2),FormMain->DesktopHeight / 2 - Card[nPlayer] -> aCardImage -> Height);
      }
      if ( nPlayer ==3 ) {
         MoveCardImage(Card[nPlayer] -> aCardImage ,FormMain->DesktopWidth / 2 - Card[nPlayer] -> aCardImage -> Width/2,FormMain->DesktopHeight / 2 - Card[nPlayer] -> aCardImage -> Height);
     }
     Pl[nPlayer]->DrawCards(1);
     FormMain->Update();

     #endif
     nPlayer++;
     if  ( nPlayer==4  )  nPlayer=1;
}

//----------------------------------------------------------------------
int TDesk::SaveToFile(char *filename) {
   TCard *Card;
   FILE *out;
   out = fopen(filename,"ab");
   if (out == NULL)
       return NULL;
   // TColoda write
   for (int i = 0; i < AColoda->aLimit; i++) {
     Card = (TCard *)AColoda->At(i);
     if (Card!=NULL) {
      fprintf(out,"%i %i ",Card->CMast,Card->CName);
     }
   }
   fprintf(out,"\n");
   fclose(out);
   return 1;
}
//----------------------------------------------------------------------
int TDesk::LoadFromFile(char *filename) {
   TCard *Card;
   FILE *in;
   int cm=0,cn=0;
   in = fopen(filename,"rb");

   if (in == NULL)
       return NULL;
   for (int i = 0; i < AColoda->aLimit; i++) {
     fscanf(in,"%i %i",&cm,&cn);
     Card = (TCard *)AColoda->At(i);
     if (Card)
        Card -> SetCard(cn,cm);
   }
   fclose(in);
   return 1;
}
//----------------------------------------------------------------------
#ifdef __BORLANDC__
void TDesk::RedrawPlayers(void) {
     FormMain->p1LabelGame->Caption = pcCameName2(Pl[1]->typegame) ;
     if (Pl[1]->currvz) {
        FormMain->p1LabelGame->Caption = FormMain->p1LabelGame->Caption + " " +IntToStr(Pl[1]->currvz);
     }
     FormMain->p2LabelGame->Caption = pcCameName2(Pl[2]->typegame) ;
     if (Pl[2]->currvz)  {
         FormMain->p2LabelGame->Caption = FormMain->p2LabelGame->Caption +" " + IntToStr(Pl[2]->currvz);
     }
     FormMain->p3LabelGame->Caption = pcCameName2(Pl[3]->typegame) ;
     if (Pl[3]->currvz)  {
        FormMain->p3LabelGame->Caption = FormMain->p3LabelGame->Caption + " " +IntToStr(Pl[3]->currvz);
     }
}
//----------------------------------------------------------------------
void TDesk::ClearInfo(void) {
      FormMain->p1LabelGame->Caption = "";
      FormMain->p2LabelGame->Caption = "";
      FormMain->p3LabelGame->Caption = "";
}
//----------------------------------------------------------------------
void TDesk::ShowPrikup(TCard *c1,TCard *c2) {
         KeyPress=0;
         if (c1) {
            c1 -> aCardImage -> Visible = true;
            c1 -> aCardImage -> Top = FormMain->DesktopHeight / 2 - c1 -> aCardImage -> Height;
            c1 -> aCardImage -> Left = FormMain->DesktopWidth / 2 - (c1 -> aCardImage -> Width*2);
            c1 -> aCardImage -> Repaint();
         }
         if (c2) {
            c2 -> aCardImage -> Visible = true;
            c2 -> aCardImage -> Top = FormMain->DesktopHeight / 2 - c2 -> aCardImage -> Height;
            c2 -> aCardImage -> Left = FormMain->DesktopWidth / 2 - c2 -> aCardImage -> Width/2;
            c2 -> aCardImage -> Repaint();
         }
         while ( !KeyPress ) {
             Application->ProcessMessages();
         }
         Beep();
}
//----------------------------------------------------------------------
void TDesk::MoveCardImage(TImage *Image ,int x,int y ) {
   int nSteps = 10;
   int dx = (x - Image -> Left) / nSteps,dy = (y - Image -> Top) / nSteps;
   for (int i = 1 ;i<=nSteps;i++ ) {
      Image -> Left = Image -> Left +dx;
      Image -> Top = Image -> Top + dy;
      Image -> Repaint();
      FormMain->Update();
//      Application->ProcessMessages();
//      Sleep(10);
   }

}
#endif
