//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Formtorg_u.h"
#include "prfconst.h"
#include "wp32.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormtorg *Formtorg;
//---------------------------------------------------------------------------
__fastcall TFormtorg::TFormtorg(TComponent* Owner)
    : TForm(Owner)
{
  DWORD Style=GetWindowLong(Handle, GWL_EXSTYLE);
  Style|=WS_EX_TOOLWINDOW;
  SetWindowLong(Handle, GWL_EXSTYLE, Style);
}
//---------------------------------------------------------------------------

void __fastcall TFormtorg::g61Click(TObject *Sender)
{
    TSpeedButton *SpeedBotton = (TSpeedButton *)Sender;
    GamesType = GamesTypeByName(SpeedBotton->Name.c_str());
    ModalResult= mrOk;
}
//---------------------------------------------------------------------------
void TFormtorg::EnableAll(void) {
    for ( int i = 0 ; i < ComponentCount; i++ )
        ((TSpeedButton *)Components[i])->Enabled = true;
}
//---------------------------------------------------------------------------
void TFormtorg::DisalbeAll(void) {
    for ( int i = 0 ; i < ComponentCount; i++ )
        ((TSpeedButton *)Components[i])->Enabled = false;
}
//---------------------------------------------------------------------------
void TFormtorg::EnableGames(TGamesType _GamesType) {
    for ( int i = 0 ; i < ComponentCount; i++ ) {
        TSpeedButton *SpeedButton = (TSpeedButton *)Components[i];
        if ( GamesTypeByName(SpeedButton->Name.c_str()) == _GamesType )
            SpeedButton ->Enabled = true;
    }

}
//---------------------------------------------------------------------------
void TFormtorg::DisalbeGames(TGamesType _GamesType) {
    for ( int i = 0 ; i < ComponentCount; i++ ) {
        TSpeedButton *SpeedButton = (TSpeedButton *)Components[i];
        if ( GamesTypeByName(SpeedButton->Name.c_str()) == _GamesType )
            SpeedButton ->Enabled = false;
    }
}
//---------------------------------------------------------------------------

void TFormtorg::DisableLessThan(TGamesType _GamesType) {
    for ( int i = 0 ; i < ComponentCount; i++ ) {
        TSpeedButton *SpeedButton = (TSpeedButton *)Components[i];
        if ( GamesTypeByName(SpeedButton->Name.c_str()) < _GamesType )
            SpeedButton ->Enabled = false;
    }

}
/*void DisalbeGames(TGamesType);
void DisableLessThan(TGamesType);*/


void __fastcall TFormtorg::GetBack(TObject *Sender)
{
    GamesType = 0;
    ModalResult= mrOk;
}
//---------------------------------------------------------------------------

void __fastcall TFormtorg::ShowBullet(TObject *Sender)
{
    GamesType = 1;
    ModalResult= mrOk;

}
//---------------------------------------------------------------------------

void __fastcall TFormtorg::FormActivate(TObject *Sender)
{
// must view main window if main windows a minimazed
        Application -> Restore();
/*        TForm *mf = Form1;
        if ( mf -> WindowState == wsMinimized )
                mf -> WindowState = wsNormal;*/
}
//---------------------------------------------------------------------------

