//---------------------------------------------------------------------------

#ifndef localeH
#define localeH

#ifndef CardH
#include "card.h"
#endif

#define MAXMASTLEN    8
#define CARD4PLAY     10
#define CARDINCOLODA  32
#define PRFDEBUG

#define CODEPAGE1251
//#define CODEPAGE437
//#define CODEPAGEKOI8
//#define CODEPAGE866

#define MAXDEPT        30

#define LEFT       0
#define RIGHT      1
#define IM         2
#define ALL        3

#define MAXGAMELEN 128

enum Tgamestype {
  undefined=0,
  raspass=56,
  halfvist=57,
  catchmiser=58,
  vist=59,
  pass=60,
  g61=61,g62,g63,g64,g65,
  g71=71,g72,g73,g74,g75,
  g81=81,g82,g83,g84,g85,
  g91=91,g92,g93,g94,g95,g96,
  g101=101,g102,g103,g104,g105
  };// g96 - miser

typedef struct {
 Tgamestype game;
 char *name;
}  TGameName;

//-------------------   

extern int kozir;
extern Tgamestype aCurrGame;

char *pcCameName(int nGame);
char *pcCameName2(int nGame);
int nGetGamePrice(Tgamestype);
int nGetGameCard(Tgamestype);
int nGetVistCard(Tgamestype);
int nGetMinCard4Vist(Tgamestype );
#pragma  warn -aus
inline int nPlayerTakeCards(TCard *p1,TCard *p2,TCard *p3,int koz ) {
   int nRetVal=0;
   TCard *CardMax;
   if ( koz!=5 ) {  //          
          nRetVal = 1;
          CardMax = p1;
          if ( *p2 > *p1 || (p2->CMast == koz && p1->CMast != koz) )  {
             CardMax = p2;
             nRetVal = 2;
          }
          if ( *p3 > *CardMax || (p3->CMast == koz && CardMax->CMast != koz) )  {
             CardMax = p3;
             nRetVal = 3;
          }
   } else {
          nRetVal = 1;
          CardMax = p1;
          if ( *p2 > *p1 ) {
             CardMax = p2;
             nRetVal = 2;
          }
          if ( *p3 > *CardMax ) {
             CardMax = p3;
             nRetVal = 3;
          }
   }
   return nRetVal; //  

}; // 1..3 -   
#pragma  warn +aus
//---------------------------------------------------------------------------
#endif
