#include "card.h"
#include "player.h"
#include "locale.h"
#include "movenode.h"
#include "ncounter.h"
#include "cardlist.h"
#include <stdlib.h>
#include <string.h>
#include <stdlib.h> //for random numbers

#ifdef __BORLANDC__
   #include "WinPrefMain_u.h"
#endif
#ifdef  PRFDEBUG
  #include <stdio.h>
  #include <alloc.h>
#endif
//-------------------------------------------------------------------------

TPlayer::TPlayer() {
    currvz=0;
    flmizer=0;
    for ( int i=1;i<=4;i++ )     mast4r[i]=0;
    aCards = new TCardList(12); // 
    aLeft  = new TCardList(10);  //    (  )
    aRight = new TCardList(10); //   (  )
    aOut   = new TCardList(2);   //  (  )
    aCardsOut = new TCardList(10); //   
    aLeftOut  = new TCardList(10);  //      (  )
    aRightOut = new TCardList(10); //     (  )
    myLastgamestype=undefined;
}
//-------------------------------------------------------------------------
TPlayer::~TPlayer() {
    CleanAll();
    delete aCards;
    delete aLeft;
    delete aRight;
    delete aOut;
    delete aCardsOut;
    delete aLeftOut;
    delete aRightOut;
}
//-----------------------------------------------------------------------
void TPlayer::CleanAll(void) {
    flmizer=0;
    currvz=0;
    for ( int i=1;i<=4;i++ )     mast4r[i]=0;
    aCards->RemoveAll();
    aLeft->RemoveAll();
    aRight->RemoveAll();
    aOut->RemoveAll();
    aCardsOut->RemoveAll();
    aLeftOut->RemoveAll();
    aRightOut->RemoveAll();
    myLastgamestype=undefined;

}
//-------------------------------------------------------------------------
void TPlayer::setmygame0(void) {
  TCard *tmp;
  for ( int i=1;i<=4;i++ )  {
    mast4r[i]=0;
  }
  for (int i=0;i<aCards->aLimit;i++) {
      tmp =  (TCard *)aCards -> At(i);
      if (tmp) {
         tmp -> MyVz = 0;
      }
  }
}
//-------------------------------------------------------------------------
void TPlayer::MakeTreeMove4miser(Tncounter plcounter ,TCardList **aPlCards,TCard *First,TCard *Second,int mast) {
   FILE *out;
   TCard *tmpcard;
   dept++;
//   if ( dept <= MAXDEPT )  {
      for (int i=0; i < CARD4PLAY; i++ ) {
         if (plcounter.nValue == nPlayer  )  {
         /*       - ,    .
         2    
           ,   3 ,  , 
                    
            ,  
         3          ,    */
             if ( First )  {
                 if ( Second ) {
                    TCard *min = First;
                    if ( *min > *Second )   {
                       min = Second;
                    }
                    tmpcard = aPlCards[plcounter.nValue]->LessThan(min);
                    if ( !tmpcard ) {
                      tmpcard = aPlCards[plcounter.nValue]->MaxCard(mast);
                    }
                 } else {
                    TCard *tmp2=NULL;
                    Tncounter tmpcounter (plcounter.nValue,1,3);
                    ++tmpcounter;
                    tmp2 = aPlCards[tmpcounter.nValue]->MinCard(mast);
                    if ( tmp2 ) {
                      TCard *min = First;
                      if ( *min > *tmp2 )   {
                          min = tmp2;
                      }
                      tmpcard = aPlCards[plcounter.nValue]->LessThan(min);
                      if ( !tmpcard ) {
                         tmpcard = aPlCards[plcounter.nValue]->MaxCard(mast);
                      }
                    } else { //      
                      tmpcard = aPlCards[plcounter.nValue]->LessThan(First);
                      if ( !tmpcard ) {
                         tmpcard = aPlCards[plcounter.nValue]->MaxCard(mast);
                      }
                    }  
                 } 

             } else {
              tmpcard = aPlCards[plcounter.nValue]->MinCard(mast);
             } 
         } else {
          tmpcard = (TCard *)aPlCards[plcounter.nValue] ->items[i];
         } 
         if (tmpcard && tmpcard->CMast == mast) {
            if ( ValidMove(First,tmpcard) ) {
                if ((out = fopen("p.txt","a"))!=NULL) {
                   for (int j=1;j<dept;j++) {
                      fprintf(out,"\t");
                   }
                   fclose(out);
                }
                if (First) {
                   if (Second) {
                     int nold = plcounter.nValue;
                     int nCard = nPlayerTakeCards(First,Second,tmpcard,mymast);
                     if ((out = fopen("p.txt","a"))!=NULL) {
                      fprintf(out,"%i %i Player %i\n",tmpcard->CMast,tmpcard->CName,plcounter.nValue);
                      fclose(out);
                     }
                     plcounter = plcounter - ( 3 - nCard);
                     if ((out = fopen("p.txt","a"))!=NULL) {
                      fprintf(out,"Pl %i get cards\n",plcounter.nValue);
                      fclose(out);
                     }                   
                     if ( this -> nPlayer == plcounter.nValue ) { // this takes a card
                      mast4r[mast]  = 1;
                      tmpcard->MyVz = 1;
                      vz++;
                     }
                     aPlCards[nold] -> Remove(tmpcard);
                     MakeTreeMove4miser(plcounter,aPlCards,NULL,NULL,mast);
                     aPlCards[nold] -> Insert(tmpcard);
                  } else {
                     int nold = plcounter.nValue;
                     aPlCards[nold] -> Remove(tmpcard);
                     if ((out = fopen("p.txt","a"))!=NULL) {
                      fprintf(out,"%i %i Player %i\n",tmpcard->CMast,tmpcard->CName,plcounter.nValue);
                      fclose(out);
                     }
                     ++plcounter;

                     MakeTreeMove4miser(plcounter,aPlCards,First,tmpcard,mast);
                     aPlCards[nold] -> Insert(tmpcard);
                   }
                } else {
                   int nold = plcounter.nValue;
                   aPlCards[nold] -> Remove(tmpcard);
                   if ((out = fopen("p.txt","a"))!=NULL) {
                    fprintf(out,"%i %i Player %i\n",tmpcard->CMast,tmpcard->CName,plcounter.nValue);
                    fclose(out);
                   }
                   ++plcounter;
                   MakeTreeMove4miser(plcounter,aPlCards,tmpcard,NULL,mast);
                   if ((out = fopen("p.txt","a"))!=NULL) {
                    fprintf(out,"%i %i End\n",tmpcard->CMast,tmpcard->CName);
                    fclose(out);
                   }
                   aPlCards[nold] -> Insert(tmpcard);
                }
            }
         }
      }
//   }
   dept--;
}
//-------------------------------------------------------------------------
void TPlayer::MakeTree4miser(int nPlFirstMove,TPlayer *LeftPlayer,TPlayer *RightPlayer,int nState) {
  TCardList *aPlCards[4];
  Tncounter  plcounter(nPlFirstMove,1,3);
  aPlCards[1] = new TCardList(12);
  aPlCards[2] = new TCardList(12);
  aPlCards[3] = new TCardList(12);
  /* nState:  0- 10 card statfill , 1 - 12 card start fill,2 - 10 card real rasklad*/
  switch ( nState )  {
    case 0: {
      makestatfill();
      Tncounter  tmp(this->nPlayer,1,3);
      ++tmp;
      aPlCards[tmp.nValue]->Assign(aLeft);
      ++tmp;
      aPlCards[tmp.nValue]->Assign(aRight);
      aPlCards[this->nPlayer]->Assign(this->aCards);
      break;
    }
    case 1: {
      //makeout4miser();
      makestatfill();
      break;
    }
    case 2: {
      aPlCards[LeftPlayer->nPlayer]->Assign(LeftPlayer->aCards);
      aPlCards[RightPlayer->nPlayer]->Assign(RightPlayer->aCards);
      break;
    }
  }


  for ( int i=1;i<=4;i++ )  mast4r[i]=0;
  vz = 0;

  dept = 0;
  MakeTreeMove4miser(plcounter,aPlCards,NULL,NULL,1);
  dept = 0;
  MakeTreeMove4miser(plcounter,aPlCards,NULL,NULL,2);
  dept = 0;
  MakeTreeMove4miser(plcounter,aPlCards,NULL,NULL,3);
  dept = 0;
  MakeTreeMove4miser(plcounter,aPlCards,NULL,NULL,4);

  aPlCards[1]->RemoveAll();
  aPlCards[2]->RemoveAll();
  aPlCards[3]->RemoveAll();
  delete aPlCards[1];
  delete aPlCards[2];
  delete aPlCards[3];

}
//-------------------------------------------------------------------------
int TPlayer::vzinmast4vist2(int _mast,int &nlocvz,int &nlocpere) {
  TCard *myc,*encmax,*encmin;
  int maxc=0,lvz=0,lpere=0;
  TCardList *my    = new TCardList(MAXMASTLEN);
  TCardList *en    = new TCardList(MAXMASTLEN);
  //  
  for (int c=7;c<=A;c++ ) {
    if ( (myc=aCards->Exist(c,_mast)) !=NULL)  {
       my->Insert(myc);
    }
    else {
      TCard *encadr=NULL;
      if ( enemy==LEFT ) {
        encadr = aLeft  ->Exist(c,_mast);
      } else {
        encadr = aRight ->Exist(c,_mast);
      }
      if ( encadr )  {
        en->Insert(new TCard(encadr->CName,encadr->CMast));
      }
    }
  }
  //   
  maxc = my->AllCard(_mast);
  if ( maxc < en->AllCard(_mast) )
     maxc = en->AllCard(_mast);

  for ( int i = 1;i<=maxc;i++ )  {
    myc = my->MinCard(_mast);
    encmax = en->MaxCard(_mast);
    encmin = en->MinCard(_mast);
    //        
    if ( myc==NULL ) {
      break;
    }
    //  

    if ( encmax==NULL && encmin==NULL)  { //   
      lvz +=my->AllCard(_mast);   //    
      for(int j=7;j<A;j++) {
         TCard *tmp2 = my -> Exist(j,_mast);
         if ( tmp2 )
            tmp2 ->MyVz =1;
      }
      break;
    }

    if ( encmax->CName > myc->CName ) { //    
      //   
      //  ,     !!!
       TCard *f = en->MoreThan(myc->CName,_mast);
       if (f)  {
         en->Free(f);
       } else {
        en->Free(encmax);
       }
       my->Remove(myc);
       //        -      -  !!!
       if ( morevz(my,en,_mast) ) {
          lpere++;
       }

     } else {   //       
        lvz++;
        myc -> MyVz = 1;
        my->Remove(myc);
        en->Free(encmin);
    }
  }
  if (!lvz)    lpere = 0;
  vz += lvz;
  pere += lpere;
  nlocvz  = lvz;
  nlocpere = lpere;

  my->RemoveAll();
  en->FreeAll();
  delete my;
  delete en;
  return lvz;
}

//-------------------------------------------------------------------------
int TPlayer::vzinmast4vist(int _mast,int &nlocvz,int &nlocpere) {
  TCard *myc,*encmax,*encmin;
  int maxc=0,lvz=0,lpere=0;
  TCardList *my    = new TCardList(MAXMASTLEN);
  TCardList *en    = new TCardList(MAXMASTLEN);
  //  
  for (int c=7;c<=A;c++ ) {
    if ( (myc=aCards->Exist(c,_mast)) !=NULL)  {
       my->Insert(myc);
    }
    else {
       en->Insert(new TCard(c,_mast));
    }
  }
  if ( my->AllCard(_mast) >= 4 && my->AllCard(_mast) <= 5 )  {
    en->Free(en->MinCard(_mast));
  }
  //   
  maxc = my->AllCard(_mast);
  if ( maxc < en->AllCard(_mast) )
     maxc = en->AllCard(_mast);

  for ( int i = 1;i<=maxc;i++ )  {
    myc = my->MinCard(_mast);
    encmax = en->MaxCard(_mast);
    encmin = en->MinCard(_mast);
    //        
    if ( myc==NULL ) {
      break;
    }
    //  

    if ( encmax==NULL && encmin==NULL)  { //   
      lvz +=my->AllCard(_mast);   //    
      for(int j=7;j<A;j++) {
         TCard *tmp2 = my -> Exist(j,_mast);
         if ( tmp2 )
            tmp2 ->MyVz =1;
      }
      break;
    }

    if ( encmax->CName > myc->CName ) { //    
      //   
      //  ,     !!!
       TCard *f = en->MoreThan(myc->CName,_mast);
       if (f)  {
         en->Free(f);
       } else {
        en->Free(encmax);
       }
       my->Remove(myc);
       //        -      -  !!!
       if ( morevz(my,en,_mast) ) {
          lpere++;
       }

     } else {   //       
        lvz++;
        myc -> MyVz = 1;
        my->Remove(myc);
        en->Free(encmin);
    }
  }
  if (!lvz)    lpere = 0;
  vz += lvz;
  pere += lpere;
  nlocvz  = lvz;
  nlocpere = lpere;

  my->RemoveAll();
  en->FreeAll();
  delete my;
  delete en;
  return lvz;
}

//-------------------------------------------------------------------------
void TPlayer::maxgame4vist2(void) {
  vz=0;     //    
  pere=0;   // 
  setmygame0();
  for (int i=1; i<=4; i++) {
    int nlocvz=0,nlocpere=0;
    if ( vzinmast4vist2(i,nlocvz,nlocpere) ) {
       mast4r[i]=1; //  
    } else {
      if ( aCards->AllCard(i) ) {
       mast4r[i]=-1; //  
      } else {
       mast4r[i]=0; //  
      }
    }
    vzat4r[i]=nlocvz;
    pere4r[i]=nlocpere;
  }

}
//-------------------------------------------------------------------------
void TPlayer::maxgame4vist(Tgamestype EnemyGamesType,Tgamestype HaveOtherVist) {
  vz=0;     //    
  pere=0;   // 
  setmygame0();
  for (int i=1; i<=4; i++) {
    int nlocvz=0,nlocpere=0;
    if ( vzinmast4vist(i,nlocvz,nlocpere) ) {
       mast4r[i]=1; //  
    } else {
      if ( aCards->AllCard(i) ) {
       mast4r[i]=-1; //  
      } else {
       mast4r[i]=0; //  
      }
    }
    vzat4r[i]=nlocvz;
    pere4r[i]=nlocpere;
  }

  if ( HaveOtherVist!=vist && vz >= nGetMinCard4Vist(EnemyGamesType) ) {
     typegame = vist;
  } else {
     typegame = pass;
  }
  if ( HaveOtherVist==pass && vz < nGetMinCard4Vist(EnemyGamesType) ) {
     typegame = halfvist;
  }
  if (EnemyGamesType == g61) {
     typegame = vist; //STALINGRAD !!!
  }
}
//-------------------------------------------------------------------------
void TPlayer::maxgame2(void) {
  mymast=0; // 
  vz=0;     //    
  pere=0;   // 
  setmygame0();
  for (int i=1; i<=4; i++) {
    if ( vzinmast2(i) ) {
       mast4r[i]=1;
    } else {
       mast4r[i]=-1;
    }
  }

}
//-------------------------------------------------------------------------
void TPlayer::maxgame(int nPlayerFirstMove) {
  int j,i,maxlen=0,sum1=0,sum2=0;
  mymast=0; // 
  vz=0;     //    
  pere=0;   // 
  setmygame0();
  for (i=1; i<=4; i++) {
    if ( vzinmast(i) ) {
       mast4r[i]=1;
    } else {
       mast4r[i]=-1;
    }
  }
  //     
  if(vz==0) {
    MakeTree4miser(nPlayerFirstMove,NULL,NULL,0);
    if ( vz==0 ) {
      flmizer=1;
    }
  }
  if ( vz  )   {
    for (i=1; i<=4; i++) {
      if( aCards->AllCard(i) > maxlen ) {
        maxlen = aCards->AllCard(i);
        mymast = i;
      }
    }
    for (i=1; i<=4; i++) {
      if(aCards->AllCard(i)==maxlen && mymast!=i) { //    
       for (j=7;j<=A;j++ )
         if (   aCards->Exist(j,i)!=NULL )
          sum1 += (  aCards->Exist(j,i)) ->CName;
       for (j=7;j<=A;j++ )
         if (   aCards->Exist(j,mymast)!=NULL )
          sum2 += (  aCards->Exist(j,mymast)) ->CName;

       if ( sum1 > sum2 )  {
         mymast = i;
         break;
        }
      }
    }
  }
}
//-------------------------------------------------------------------------
int TPlayer::vzinmast2(int _mast) {
  /*  -    (  )   ( )
           ,   ,   
    -       
   */
  TCard *myc,*encmax,*encmin;
  int maxc,lvz=0,lpere=0,c,maxlen=0;
  TCardList *my    = new TCardList(MAXMASTLEN);
  TCardList *en    = new TCardList(MAXMASTLEN);
  TCardList *enleft= new TCardList(MAXMASTLEN);
  TCardList *enright= new TCardList(MAXMASTLEN);

  //make one powerful list from 2 left and right
  for ( c=7;c<=A;c++ ) {
     if ( aLeft->Exist(c,_mast) ) {
      enleft->Insert(new TCard(c,_mast));
     }
     if ( aRight->Exist(c,_mast) ) {
      enright->Insert(new TCard(c,_mast));
     }
  }
  enright->mySort();
  enleft->mySort();
  maxlen = enleft->AllCard(_mast)>enright->AllCard(_mast)?enleft->AllCard(_mast):enright->AllCard(_mast);

  for ( c=1;c<=maxlen;c++ ) {
    if ( (encmax=enleft->MaxCard(_mast)) == NULL )  {
      if ( (encmax=enright->MaxCard(_mast)) == NULL ) {
        break;
      }
    } else {
      if ( (encmin = enright->MaxCard(_mast)) !=NULL  )  {
        if ( *encmin > *encmax )  {
          encmax = encmin;
        }
      }  else {
        break;
      }
    }
    en->Insert(new TCard(encmax->CName,encmax->CMast));
  }
  delete enleft;
  delete enright;
  //  

  for ( c=7;c<=A;c++ ) {
    if ( (myc=aCards->Exist(c,_mast)) !=NULL)
       my->Insert(myc);
  }
  maxc = my->AllCard(_mast);
  if ( maxc < en->AllCard(_mast) )
     maxc = en->AllCard(_mast);

  for ( int i = 1;i<=maxc;i++ )  {
    myc = my->MaxCard(_mast);
    encmax = en->MaxCard(_mast);
    encmin = en->MinCard(_mast);
    //        
    if ( myc==NULL ) {
      break;
    }
    //  

    if ( encmax==NULL && encmin==NULL)  { //   
      lvz +=my->AllCard(_mast);   //    
      for(int j=7;j<A;j++) {
         TCard *tmp2 = my -> Exist(j,_mast);
         if ( tmp2 )
            tmp2 ->MyVz =1;
      }
      break;
    }

    if ( encmax->CName > myc->CName ) { //    
      //   , 
      //  ,     !!!
       TCard *f = en->MoreThan(myc->CName,_mast);
       if (f)  {
         en->Free(f);
       } else {
        en->Free(encmax);
       }
       my->Remove(myc);
       //        -      -  !!!
       if ( morevz(my,en,_mast) ) {
          lpere++;
       }

     } else {   //       
        lvz++;
        myc -> MyVz = 1;
        my->Remove(myc);
        en->Free(encmin);
    }
  }
  if (!lvz)    lpere = 0;
  vz += lvz;
  pere += lpere;
  my->RemoveAll();
  en->FreeAll();

  delete my;
  delete en;
  return lvz;
}
//-------------------------------------------------------------------------
int TPlayer::vzinmast(int _mast) {
  /*  -    (  )   ( )
           ,   ,   
    -       
   */
  TCard *myc,*encmax,*encmin;
  int maxc=0,lvz=0,lpere=0;
  TCardList *my    = new TCardList(MAXMASTLEN);
  TCardList *en    = new TCardList(MAXMASTLEN);
  //  
  for (int c=7;c<=A;c++ ) {
    if ( (myc=aCards->Exist(c,_mast)) !=NULL)  {
       my->Insert(myc);
    }
    else {
       en->Insert(new TCard(c,_mast));
    }
  }
  //     4   6      
  //   
  if ( my->AllCard(_mast) >= 4 && my->AllCard(_mast) <= 5 )  {
    en->Free(en->MinCard(_mast));
  }
  //en->mySort();
  //my->mySort();
  // end   
  //   
  maxc = my->AllCard(_mast);
  if ( maxc < en->AllCard(_mast) )
     maxc = en->AllCard(_mast);

  for ( int i = 1;i<=maxc;i++ )  {
    myc = my->MaxCard(_mast);
    encmax = en->MaxCard(_mast);
    encmin = en->MinCard(_mast);
    //        
    if ( myc==NULL ) {
      break;
    }
    //  

    if ( encmax==NULL && encmin==NULL)  { //   
      lvz +=my->AllCard(_mast);   //    
      for(int j=7;j<A;j++) {
         TCard *tmp2 = my -> Exist(j,_mast);
         if ( tmp2 )
            tmp2 ->MyVz =1;
      }
      break;
    }

    if ( encmax->CName > myc->CName ) { //    
      //   , 
      //  ,     !!!
       TCard *f = en->MoreThan(myc->CName,_mast);
       if (f)  {
         en->Free(f);
       } else {
        en->Free(encmax);
       }
       my->Remove(myc);
       //        -      -  !!!
       if ( morevz(my,en,_mast) ) {
          lpere++;
       }

     } else {   //       
        lvz++;
        myc -> MyVz = 1;
        my->Remove(myc);
        en->Free(encmin);
    }
  }
  if (!lvz)    lpere = 0;
  vz += lvz;
  pere += lpere;
  my->RemoveAll();
  en->FreeAll();
  delete my;
  delete en;
  return lvz;
}
//-------------------------------------------------------------------------
int TPlayer::morevz(TCardList *my,TCardList *en,int mast) {
//   !!!    !!!
//  return my->AllCard(mast) >= en->AllCard(mast);
  TCardList *lmy=new TCardList(12);
  TCardList *len=new TCardList(12);
  int c, maxc,RetVal=NULL;
  TCard *myc,*encmax,*encmin;
  for (c=7;c<=A;c++ )
    if ( (myc=my->Exist(c,mast)) !=NULL)
       lmy->Insert(new TCard(c,mast));
  for (c=7;c<=A;c++ )
    if ( (myc=en->Exist(c,mast)) !=NULL)
       len->Insert(new TCard(c,mast));
  maxc = lmy->AllCard(mast);
  if ( maxc < len->AllCard(mast) )
     maxc = len->AllCard(mast);
  for ( int i = 1;i<=maxc;i++ )  {
    myc = lmy->MaxCard(mast);
    encmax = len->MaxCard(mast);
    encmin = len->MinCard(mast);
    //        
    if ( myc==NULL ) {
      break;
    }    //  
    if ( encmax==NULL )  {
      break;
    } //   
    if ( encmax->CName > myc->CName ) { //    
       lmy->Free(myc);
       len->Free(encmax);
    } else {
       RetVal++;
       lmy->Free(myc);
       len->Free(encmin);
    }
  }
  delete lmy;
  delete len;
  return RetVal;
}
//-------------------------------------------------------------------------
void TPlayer::makeout(int nPlayerFirstMove) {
  //            100% 
  //   !
  //   ,    12 
  TCard *one,*two;
  TCard *sone,*stwo;
  int v=0,p=0;
  //     ,     ,   
  for (int i=0;i<12;i++) {
    one =(TCard *) aCards -> At(i);
    aCards->AtRemove(i);
    for (int j=0;j<12;j++) {
      if (j!=i) {
         TPlayer *TmpPl = new TPlayer();
         two =(TCard *) aCards -> At(j);
         aCards->AtRemove(j);
         TmpPl ->aCards->Assign(aCards);
         TmpPl ->aCards->mySort();
         TmpPl  -> maxgame(nPlayerFirstMove);
         if ( v < TmpPl ->vz  || ( v == TmpPl ->vz && p>TmpPl->pere) ) {
           v = TmpPl -> vz;
           p = TmpPl -> pere;
           sone = one; //   ,     
           stwo = two;
         }
         TmpPl -> CleanAll();
         delete TmpPl;
         aCards -> AtPut(j,two);
       }
    }
    aCards->AtPut(i,one); //    
  }
  aCards->Remove(sone);
  aCards->Remove(stwo);
  aOut->Insert(sone);
  aOut->Insert(stwo);
  aCards -> mySort();
  #ifdef __BORLANDC__
    DrawCards(1);
    sone->DrawCard(0,0,0);
    stwo->DrawCard(0,0,0);
  #endif
}
//-------------------------------------------------------------------------
void TPlayer::makestatfill(void) {
   int lr=LEFT;
   for (int m=1;m<=4;m++)
     for (int c=A;c>=7;c-- )
       if ( !aCards->Exist(c,m) ) {
         if (lr) {
           aLeft->Insert(new TCard(c,m));
         } else {
           aRight->Insert(new TCard(c,m));
         }
         lr = !lr;
       }
}
//-------------------------------------------------------------------------
TCard *TPlayer::makemove(TCard *lMove,TCard *rMove) {
  TCard *RetVal;
  if ( !rMove && !lMove) { // 
    switch ( typegame )  {
      case raspass: {
         break;
      };
      case pass:{
         RetVal = mypassandvist1();
         break;
      };
      case vist:{
         RetVal = mypassandvist1();
         break;
      }
      case g96: {
        break;
      };
      default: {
         RetVal = mygame1();
      }
    }
  }
  if (!lMove && rMove ) { //   
    switch ( typegame )  {
      case raspass: {
         break;
      };
      case pass:{
         RetVal = mypassandvist2(rMove);
         break;
      };
      case vist:{
         RetVal = mypassandvist2(rMove);
         break;
      }
      case g96: {
        break;
      };
      default: {
         RetVal = mygame2(rMove);
         break;
      }
    }
  }
  //-----------------------------------
  if (lMove && rMove) {
    switch ( typegame )  {
      case raspass: {
         break;
      };
      case pass:{
         RetVal = mypassandvist3(lMove,rMove);
         break;
      };
      case vist:{
         RetVal = mypassandvist3(lMove,rMove);
         break;
      }
      case g96: {
        break;
      };
      default: {
         RetVal = mygame3(lMove,rMove);
         break;
      }
    }
  }
  aCards    -> Remove(RetVal);
  aCardsOut -> Insert(RetVal);
  return RetVal;
}
//-------------------------------------------------------------------------
TCard * TPlayer::mygame3(TCard *lMove,TCard *rMove) {
    TCard *RetVal=NULL;
    if ( lMove->CMast==mymast ) {
       //   
      if ( rMove->CMast == mymast )  {
         //  
         if ( *lMove > *rMove )  {
             RetVal = aCards->MoreThan(lMove);
             if ( !RetVal )  RetVal = aCards->MinCard(lMove->CMast);
             if ( !RetVal )  RetVal = mygame3vs(lMove,rMove);
         } else {
             RetVal = aCards->MoreThan(rMove);
             if ( !RetVal )  RetVal = aCards->MinCard(lMove->CMast);
             if ( !RetVal )  RetVal = mygame3vs(lMove,rMove);
         }
      } else {
        //   
         RetVal = aCards->MoreThan(lMove);
         if ( !RetVal )   RetVal = aCards->MinCard(lMove->CMast);
         if ( !RetVal )  RetVal = mygame3vs(lMove,rMove);
      }
    }  else {
      //   
      if ( aCards->AllCard(lMove->CMast) )  {
        //         
         if ( rMove->CMast == mymast ) {
           //   
           RetVal = aCards->MinCard(lMove->CMast);
         }
         if ( rMove->CMast == lMove->CMast)  {
           //  - 
            if ( *lMove > *rMove )  {
                RetVal = aCards->MoreThan(lMove);
                if ( !RetVal )   RetVal = aCards->MinCard(lMove->CMast);
            } else {
                RetVal = aCards->MoreThan(rMove);
                if ( !RetVal )  RetVal = aCards->MinCard(lMove->CMast);
            }
         }
         if ( !(rMove->CMast == lMove->CMast) && !(rMove->CMast == mymast))  {
           //    !!!
           RetVal = aCards->MoreThan(lMove);
           if ( !RetVal ) RetVal = aCards->MinCard(lMove->CMast);
         }
      } else {
         //         
         if ( rMove->CMast == mymast ) {
           //   
           RetVal = aCards->MoreThan(rMove);
           if ( !RetVal ) RetVal = aCards -> MinCard(mymast);
           if ( !RetVal )  RetVal = mygame3vs(lMove,rMove);
         }
         if ( rMove->CMast == lMove->CMast)  {
           //  - 
           RetVal = aCards -> MinCard(mymast);
           if ( !RetVal )  RetVal = mygame3vs(lMove,rMove);
         }
         if ( rMove->CMast != lMove->CMast && rMove->CMast != mymast)  {
           //    !!!
           RetVal = aCards -> MinCard(mymast);
           if ( !RetVal )  RetVal = mygame3vs(lMove,rMove);
         }
      }
    }
    return RetVal;
}
//-------------------------------------------------------------------------
#ifdef __BORLANDC__
#pragma argsused
#endif
TCard * TPlayer::mygame3vs(TCard *lMove,TCard *rMove) {

   //               
   //     !!!       !!!
   //  -  
   //          
   //    -          
  int i,j,ms[5]={0,0,0,0,0},minindex=0;
  float msl[5]={100,100,100,100,100},min=100;
  for (i=1;i<=4;i++ ) {
    int allc = aCards -> AllCard(i);
    if ( allc )  {
      for (j=7;j<=A;j++ ) {
          if (   aCards->Exist(j,i) ) {
             ms[i] += (  aCards->Exist(j,i)) ->MyVz;
          }
      }
      msl[i] = ms[i]/allc;
      if ( msl[i]<min ) {
        min = msl[i];
        minindex = i;
      }
      if ( ! ms[i]  )   //  -     
          return aCards->MinCard(i);
    }
  }
  return aCards->MinCard(minindex);
}
#ifdef __BORLANDC__
#pragma -argsused
#endif

//-------------------------------------------------------------------------
TCard * TPlayer::mypassandvist3(TCard *lMove,TCard *rMove) {
 TCard *RetVal=NULL;
 maxgame4vist2();
 if ( enemy==RIGHT ) {
    if ( lMove->CMast==mymast ) {
       //   
      if ( rMove->CMast == mymast )  {
         //  
         if ( *lMove > *rMove )  {
              //    
             RetVal = aCards->MinCard(lMove->CMast);
             if ( !RetVal )  RetVal = mygame3vs(lMove,rMove); //   -  
         } else {
             RetVal = aCards->MoreThan(rMove);
             if ( !RetVal )  RetVal = aCards->MinCard(lMove->CMast);
             if ( !RetVal )  RetVal = mygame3vs(lMove,rMove);
         }
      } else {
        //   
         RetVal = aCards->MinCard(mymast);
         if ( !RetVal )  RetVal = mygame3vs(lMove,rMove);
      }
    }  else {
      //   
      if ( aCards->AllCard(lMove->CMast) )  {
        //         
         if ( rMove->CMast == mymast ) {
           //   
           RetVal = aCards->MinCard(lMove->CMast);
         }
         if ( rMove->CMast == lMove->CMast)  {
           //  - 
            if ( *lMove > *rMove )  {
                RetVal = aCards->MinCard(lMove->CMast);
            } else {
                RetVal = aCards->MoreThan(rMove);
                if ( !RetVal )  RetVal = aCards->MinCard(lMove->CMast);
            }
         }
         if ( !(rMove->CMast == lMove->CMast) && !(rMove->CMast == mymast))  {
           //    !!!
           RetVal = aCards->MinCard(lMove->CMast);
         }
      } else {
         //         
         if ( rMove->CMast == mymast ) {
           //   
           RetVal = aCards->MoreThan(rMove);
           if ( !RetVal ) RetVal = aCards -> MinCard(mymast);
           if ( !RetVal )  RetVal = mygame3vs(lMove,rMove);
         }
         if ( rMove->CMast == lMove->CMast)  {
           //  - 
           RetVal = aCards -> MinCard(mymast);
           if ( !RetVal )  RetVal = mygame3vs(lMove,rMove);
         }
         if ( !(rMove->CMast == lMove->CMast) && !(rMove->CMast == mymast))  {
           //    !!!
           RetVal = aCards -> MinCard(mymast);
           if ( !RetVal )  RetVal = mygame3vs(lMove,rMove);
         }
      }
    }
 } else { //enemy ==LEFT
    if ( lMove->CMast==mymast ) {
       //   
      if ( rMove->CMast == mymast )  {
         //  
         if ( *lMove > *rMove )  {
             RetVal = aCards->MoreThan(lMove);
             if ( !RetVal )   RetVal = aCards->MinCard(lMove->CMast);
             if ( !RetVal )  RetVal = mygame3vs(lMove,rMove);
         } else {
             RetVal = aCards->MinCard(lMove->CMast);
             if ( !RetVal )  RetVal = aCards->MinCard(lMove->CMast);
             if ( !RetVal )  RetVal = mygame3vs(lMove,rMove);
         }
      } else {
        //   
         RetVal = aCards->MoreThan(lMove);
         if ( !RetVal )   RetVal = aCards->MinCard(lMove->CMast);
         if ( !RetVal )  RetVal = mygame3vs(lMove,rMove);
      }
    }  else {
      //   
      if ( aCards->AllCard(lMove->CMast) )  {
        //         
         if ( rMove->CMast == mymast ) {
           //   
           RetVal = aCards->MinCard(lMove->CMast);
         }
         if ( rMove->CMast == lMove->CMast)  {
           //  - 
            if ( *lMove > *rMove )  {
                RetVal = aCards->MoreThan(lMove);
                if ( !RetVal )   RetVal = aCards->MinCard(lMove->CMast);
            } else {
                RetVal = aCards->MinCard(lMove->CMast);
            }
         }
         if ( !(rMove->CMast == lMove->CMast) && !(rMove->CMast == mymast))  {
           //    !!!
           RetVal = aCards->MoreThan(lMove);
           if ( !RetVal ) RetVal = aCards->MinCard(lMove->CMast);
         }
      } else {
         //         
         if ( rMove->CMast == mymast ) {
           //   
           RetVal = aCards -> MinCard(mymast);
           if ( !RetVal )  RetVal = mygame3vs(lMove,rMove);
         }
         if ( rMove->CMast == lMove->CMast)  {
           //  - 
           RetVal = aCards -> MinCard(mymast);
           if ( !RetVal )  RetVal = mygame3vs(lMove,rMove);
         }
         if ( !(rMove->CMast == lMove->CMast) && !(rMove->CMast == mymast))  {
           //    !!!
           RetVal = aCards -> MinCard(mymast);
           if ( !RetVal )  RetVal = mygame3vs(lMove,rMove);
         }
      }
    }
 }
 return RetVal;
}
//-------------------------------------------------------------------------
TCard * TPlayer::mypassandvist3vs(TCard *lMove,TCard *rMove) {
         return mygame3vs(lMove,rMove) ;
}
//-------------------------------------------------------------------------
inline int TPlayer::ValidMove(TCard *first,TCard *acard) {
  if ( !first ) return 1;
  if ( first -> CMast == acard -> CMast ) {
    return 1;
  } else {
    if ( (! aCards->AllCard(first -> CMast) && acard -> CMast == mymast)
      || (! aCards->AllCard(first -> CMast) && mymast==5) )  {// !         - 
       return 1;
    }
  }
  return 0;
}
//-------------------------------------------------------------------------
TCard *TPlayer::mygame2(TCard *rMove) {
    TCard *RetVal=NULL;
    if ( rMove->CMast!=mymast ) { //    
      if ( aCards->AllCard(rMove->CMast) && aLeft->AllCard(rMove->CMast)  ) {
         //         
         TCard *CTmpR=aCards->MoreThan(rMove),*CTmpL=aCards->MoreThan(aLeft->MaxCard(rMove->CMast));
         if ( CTmpR ) {
            if ( CTmpL )   {
               if ( *CTmpL > *CTmpR)   {
                  RetVal = CTmpL ;
               } else {
                  RetVal = CTmpR;
               }
            } else {
               //        
               //     
               RetVal = aCards->LessThan(aLeft->MaxCard(rMove->CMast));
            }
         } else {
               RetVal = aCards->MinCard(rMove->CMast);
         }
      }
      if ( !aCards->AllCard(rMove->CMast) && aLeft->AllCard(rMove->CMast) )  {
         //       
         RetVal = aCards->MinCard(mymast);
         if ( !RetVal ) RetVal = mypassandvist3vs(NULL,rMove);
      }
      if ( aCards->AllCard(rMove->CMast) && !aLeft->AllCard(rMove->CMast) )  {
         //       
         if ( aLeft->AllCard(mymast) )  {
            RetVal = aCards->MinCard(rMove->CMast);
         } else {
            RetVal = aCards->MoreThan(rMove);
            if ( !RetVal ) RetVal =  aCards->MinCard(rMove->CMast);
         }
      }
      if ( !aCards->AllCard(rMove->CMast) && !aLeft->AllCard(rMove->CMast) )  {
         //       
         if ( aLeft->AllCard(mymast) )  {
            //    
            if ( aCards->AllCard(mymast) )  {
              //    
              RetVal = aCards->MoreThan(aLeft->MaxCard(mymast));
              if ( !RetVal ) RetVal = aCards->MinCard(mymast);
            } else {
              //    
              if ( !RetVal ) RetVal = mypassandvist3vs(NULL,rMove);
            }
         } else {
            //    
            if ( aCards->AllCard(mymast) )  {
              //    
              RetVal = aCards->MinCard(mymast);
            } else {
              //    
              if ( !RetVal ) RetVal = mypassandvist3vs(NULL,rMove);
            }
         }
      }
    } else {
        //   
      if ( aCards->AllCard(rMove->CMast) && aLeft->AllCard(rMove->CMast)  ) {
              //      
         TCard *CTmpR=aCards->MoreThan(rMove),*CTmpL=aCards->MoreThan(aLeft->MaxCard(rMove->CMast));
         if ( CTmpR ) {
            if ( CTmpL )   {
               if ( *CTmpL > *CTmpR)   {
                  RetVal = CTmpL ;
               } else {
                  RetVal = CTmpR;
               }
            } else {
               //        
               //     
               RetVal = aCards->LessThan(aLeft->MaxCard(rMove->CMast));
            }
         } else {
               RetVal = aCards->MinCard(rMove->CMast);
         }
      }
      if ( !aCards->AllCard(rMove->CMast) && aLeft->AllCard(rMove->CMast) )  {
         //   y    
         RetVal = aCards->MinCard(mymast);
         if ( !RetVal ) RetVal = mypassandvist3vs(NULL,rMove);
      }
      if ( aCards->AllCard(rMove->CMast) && !aLeft->AllCard(rMove->CMast) )  {
         //       
            RetVal = aCards->MoreThan(rMove);
            if ( !RetVal ) RetVal =  aCards->MinCard(rMove->CMast);
      }
      if ( !aCards->AllCard(rMove->CMast) && !aLeft->AllCard(rMove->CMast) )  {
         //     !!!
         RetVal = mypassandvist3vs(NULL,rMove);
      }
    }
    return RetVal;
}

//-------------------------------------------------------------------------

TCard *TPlayer::mypassandvist2(TCard *rMove) {
   TCard *RetVal=NULL;
   maxgame4vist2();
   if ( enemy==RIGHT ) {
       RetVal = aCards->MoreThan(rMove);
       if ( !RetVal) RetVal = aCards -> MinCard(rMove -> CMast );
       if ( !RetVal) RetVal = aCards -> MinCard(mymast);
       if ( !RetVal) RetVal = mypassandvist3vs(NULL,rMove);
   } else { // enemy ==LEFT
       //           
       //   1    2   
       //    int ValidMove(TCard *first,TCard *acard,int koz); //    
       int m=0;
       if ( aCards->AllCard(rMove->CMast) ) m=rMove->CMast;  //      
       if ( !m && aCards->AllCard(mymast) ) m=mymast; //  
       if ( !m )   RetVal = mypassandvist3vs(NULL,rMove);  //     
       if ( !RetVal ) {
           TCard *mcmove=NULL;//,*enmove=NULL;
           for ( int c = A;c >= 7;c-- ) {
              TCard *mc,*ec;
              mc = aCards -> Exist(c,m);
              ec=NULL;
              if ( mc )  {
                 TPlayer *np = new TPlayer();
                 np -> aCards -> Assign(aLeft);
                 np -> mymast = mymast;
                 ec = np->mygame3(mc,rMove);
                 delete np;
              }
              if ( ec ) {
                 if ( ec->CMast==mc->CMast && ec->CName < mc->CName ) {
                    mcmove = mc; //enmove = ec;
                 }
              }
           }
           if ( mcmove )  { RetVal =mcmove; }
           else { RetVal = aCards -> MinCard(m); }
       }
   }
   return RetVal;
}
//-------------------------------------------------------------------------
TCard *TPlayer::mygame1(void) {
// 1  
// 2   
// 3   
   TCard *RetVal=NULL,*MaxEnMyMastCard=NULL;
   int ek=0,lr=NOSIDE;
   int i;
   //,lr=0;
   if ( (ek = aLeft -> AllCard(mymast)) != 0 ) {
     //lr = LEFT;
     MaxEnMyMastCard = aLeft -> MaxCard(mymast);
     lr = LEFT;
   }
   if ( ek < aRight -> AllCard(mymast)) {
      //lr = RIGHT;
      if (MaxEnMyMastCard && aRight -> MaxCard(mymast)) {
         if ( *MaxEnMyMastCard < *(aRight -> MaxCard(mymast)) ) {
             MaxEnMyMastCard = aRight -> MaxCard(mymast);
             lr = RIGHT;
         }
      }
   }
   int oldm=mymast;
   int oldvz = vz;
   int oldpere = pere;
   maxgame2();
   mymast=oldm;
   vz=oldvz;
   pere=oldpere;
   if ( ek )  {
      //     !!!
      RetVal =  aCards->MaxCard(mymast);
      //      !!!
/*      if (RetVal) {
         if ( ek == 1 && *MaxEnMyMastCard > *RetVal ) {
            if (lr == LEFT ) {
               RetVal = aCards->MinCard(aLeft->EmptyMast(mymast));
            } else {
               RetVal = aCards->MinCard(aRight->EmptyMast(mymast));
            }
         }
      }*/
      if ( !RetVal ) {
         for ( i =1 ;i<=4;i++ ) {
            if ( mast4r[i]==1 && i!=mymast)  {
               if ( !aCards->AllCard(i) )  {
                  //   
                  mast4r[i]=0;
               } else {
                  RetVal = aCards->MaxCard(i);
               }
            }
         }
      }
      if ( !RetVal ) {
        for ( i =1 ;i<=4;i++ ) {
           if ( mast4r[i]==-1  && i!=mymast)  {
              if ( !aCards->AllCard(i) )  {
                 //   
                 mast4r[i]=0;
              } else {
                 RetVal = aCards->MinCard(i);
              }
           }
        }
      }
      if ( !RetVal) RetVal = mygame1vs();
   } else { //    
      //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      //           
      //   -         
      //    ,    -   
//      int i;
      for ( i =1 ;i<=4;i++ ) {
         if ( mast4r[i]==1 && i!=mymast)  {
            if ( !aCards->AllCard(i) )  {
               //   
               mast4r[i]=0;
            } else {
               RetVal = aCards->MaxCard(i);
            }
         }
      }
      if ( !RetVal )  {
        RetVal = aCards->MaxCard(mymast);
      }
      if ( !RetVal )   {
         for (  i =1 ;i<=4;i++ ) {
            if ( i== mymast )  break;
            if ( mast4r[i]==-1 )  {
               if ( !aCards->AllCard(i) )  {
                  //   
                  mast4r[i]=0;
               } else {
                  RetVal = aCards->MinCard(i);
               }
            }
         }
      }
      if ( !RetVal ) RetVal = mygame1vs();
   }
   return RetVal;
}
//-------------------------------------------------------------------------
TCard *TPlayer::mygame1vs(void) {
   TCard *RetVal=NULL,*my,*left,*right;
   int sum,min=8,mast=0;
   for ( int m1 = 1;m1<=4 ;m1++ ) {
       for ( int c1=7;c1<=A;c1++ ) {
          my = aCards->Exist(c1,m1);
          if ( my )  { //   -  
             for ( int m2 = 1;m2<=4 ;m2++ )  {
                for ( int c2=7;c2<=A;c2++ )  {
                   left = aLeft->Exist(c2,m2);
                   if ( left && ValidMove(my,left)) {
                      for ( int m3 = 1;m3<=4 ;m3++ )  {
                         for ( int c3=7;c3<=A;c3++ )  {
                            right = aRight->Exist(c3,m3);
                            if ( right && ValidMove(my,right) )  {
                                // ,   ,  -      !!!
                                if ( my == ismy(my,left,right,mymast) )  {
                                   RetVal=my;
                                   goto exitmygame1vs;
                                }
                            }
                         }
                      }
                   } //if ( left && ValidMove(my,left,mymast)) {
                }
             }
          } // if (my)
       }
   }
   if ( RetVal==NULL )  { //    !!!
      for ( int m=1;m<=4;m++ ) {
         int nmlen=aCards->AllCard(m);
         sum = 0 ;

         for ( int c=7;c<=A;c++ ) {
            my = aCards->Exist(c,m);
            if ( my )   sum += my->MyVz;
         }
         if ( sum<min && nmlen) {
            mast=m;
            min = sum;
         }
      }
   }
   if ( mast )
      RetVal = aCards->MinCard(mast);
exitmygame1vs:
  return RetVal;
}
//-------------------------------------------------------------------------
inline TCard *TPlayer::ismy(TCard *my,TCard *left,TCard *right,int koz) {
   TCard *maxc=NULL;
   if ( *left > *right || (left->CMast==koz && right->CMast!=koz) )
      maxc = left;
   if ( *right > *left || (right->CMast==koz && left->CMast!=koz) )
      maxc = left;
   if ( *my > *maxc || (my->CMast==koz && maxc->CMast!=koz) )
      maxc = my;
   return maxc;
}
//-------------------------------------------------------------------------
TCard *TPlayer::mypassandvist1(void) {
   TCard *RetVal=NULL;
   int i;
//         !!!
   maxgame4vist2();

   if ( enemy == LEFT ) {
      if ( aRight->AllCard(mymast) )  { //  ,        
        for ( i=1;i<=4;i++ )  {
           if ( i==mymast ) break;
           if ( aCards->AllCard(i) && aLeft->AllCard(i) && !aRight->AllCard(i) )
              RetVal = aCards->MinCard(i);
        }
      }
      if ( !RetVal ) {
         for (  i =1 ;i<=4;i++ ) {
            if ( mast4r[i]==-1 )  {
              RetVal = aCards->MinCard(i);
              break;
            }
         }
      }
      if ( !RetVal ) {
         int v=0,p=10,m=0;
         for (  i =1 ;i<=4;i++ ) {
            if ( mast4r[i]==1 )  {
              if ( vzat4r[i] > v || (vzat4r[i] == v && pere4r[i] < p) ) {
                v=vzat4r[i];
                p=pere4r[i];
                m=i;
              }
            }
         }
         RetVal = aCards->MaxCard(m);
      }
      if ( !RetVal )  {
          // aLeft->EmptyMast(mymast);      
          RetVal = aCards->MinCard(aLeft->EmptyMast(mymast));
      }
/*      if ( !RetVal )   {
         for (  i =1 ;i<=4;i++ ) {
            if ( i== mymast )  break;
            if ( mast4r[i]==-1 )  {
               if ( !aCards->AllCard(i) )  {
                  //   
                  mast4r[i]=0;
               } else {
                  TCard *tmp = aCards->MaxCard(i);
                  if ( tmp && tmp->CName != A )  {
                    RetVal = aCards->MinCard(i);
                  }
               }
            }
         }
      }*/
      /*if ( !RetVal )   {
         for (  i =1 ;i<=4;i++ ) {
            if ( i== mymast )  break;
            if ( mast4r[i]==1 )  {
               if ( !aCards->AllCard(i) )  {
                  //   
                  mast4r[i]=0;
               } else {
                  RetVal = aCards->MinCard(i);
               }
            }
         }
      }*/
      if ( !RetVal ) RetVal = mygame1vs();
   } else { // enemy ==RIGHT
      if ( aLeft->AllCard(mymast) )  { //  ,        
        for ( i=1;i<=4;i++ )  {
           if ( i==mymast ) break;
           if ( aCards->AllCard(i) && aRight->AllCard(i) && !aLeft->AllCard(i) )
              RetVal = aCards->MinCard(i);
        }
      }
      if ( !RetVal ) {
         int v=0,p=10,m=0;
         for (  i =1 ;i<=4;i++ ) {
            if ( mast4r[i]==1 )  {
              if ( vzat4r[i] > v || (vzat4r[i] == v && pere4r[i] < p) ) {
                v=vzat4r[i];
                p=pere4r[i];
                m=i;
              }
            }
         }
         RetVal = aCards->MaxCard(m);
      }
      if ( !RetVal ) {
         for (  i =1 ;i<=4;i++ ) {
            if ( mast4r[i]==-1 )  {
              RetVal = aCards->MinCard(i);
              break;
            }
         }
      }
      if ( !RetVal )  {
          // aLeft->EmptyMast(mymast);      
          RetVal = aCards->MinCard(aRight->EmptyMast(mymast));
      }
/*      if ( !RetVal )   {
         for (  i =1 ;i<=4;i++ ) {
            if ( i== mymast )  break;
            if ( mast4r[i]==1 )  {
               if ( !aCards->AllCard(i) )  {
                  //   
                  mast4r[i]=0;
               } else {
                  RetVal = aCards->MaxCard(i);
               }
            }
         }
      }
      if ( !RetVal )   {
         for (  i =1 ;i<=4;i++ ) {
            if ( i == mymast )  break;
            if ( mast4r[i]==-1 )  {
               if ( !aCards->AllCard(i) )  {
                  //   
                  mast4r[i]=0;
               } else {
                  RetVal = aCards->MaxCard(i);
               }
            }
         }
      }*/
      if ( !RetVal ) RetVal = mygame1vs();

   }
   return RetVal;
}
//-----------------------------------------------------------------------
Tgamestype TPlayer::nTorg(Tgamestype nMaxg,int _nPlayer,int nPlayerFirstMove) {
  //     
  Tgamestype nmyMaxg;
  Tgamestype nRetVal;
  maxgame(nPlayerFirstMove);
  nmyMaxg=vz*10+mymast;
  nRetVal=pass;
  // ...    5 ,    
  if ( flmizer ) {
    nRetVal=g96;
  }
  if ( nmyMaxg>=40 && nmyMaxg<=44 && nMaxg==pass && pere==0 && _nPlayer==3) {
    //   -  !!!      ?
    // _nPlayer==3 -         
    nRetVal=g61;
  }
  if ( nmyMaxg>=51 && nmyMaxg<=54 && nMaxg==pass) {
     nRetVal=g61;
  }
  if (nRetVal!=pass) {
    myLastgamestype=nRetVal;
    return nRetVal;
  }
  if ( myLastgamestype == nMaxg )  {
    return myLastgamestype;
  }


  if (nmyMaxg>nMaxg) {
     int ntmpvz,ntmpmast;
     ntmpvz = nMaxg/10; //  
     ntmpmast =nMaxg - ntmpvz*10; // 
     if (ntmpmast==5) {
           //      !!!
           //  
           //   1 
            ntmpmast=1;
            ntmpvz++;
     } else {
             //  
            ntmpmast++;
     }
     nRetVal = ntmpvz*10+ntmpmast;
  }
  myLastgamestype=nRetVal;
  return nRetVal;
}
//-----------------------------------------------------------------------
void TPlayer::printcards(void) {
   printf("\n ----------  %i",nPlayer);
   aCards->mySort();
   for ( int i=0;i< 12;i++) {
      TCard *nc = (TCard *)aCards->At(i);
      if (nc!=NULL) {
            printf("\n  %i  %i  %i",nc->CMast,nc->CName ,nc->MyVz );
      }
   }
}
//-----------------------------------------------------------------------
Tgamestype TPlayer::SayGame(Tgamestype gmax) {
          Tgamestype oldgmax = gmax;
          if ( gmax > vz*10+ mymast )   {
             vz  = (gmax/10);
          }
          gmax = vz*10+mymast;
          if (gmax <oldgmax) {
             vz  = 1+(oldgmax/10);
             gmax =  vz*10+mymast;
          }
          typegame = gmax;
          return typegame;
}
//-----------------------------------------------------------------------
#ifdef __BORLANDC__
void TPlayer::DrawCards(int visible) {
 int delatx=10,j=0;
 TCard *my;
 if (aCards -> aCount) {
    delatx = aPanel->Width / (aCards -> aCount+2);
 }
 aCards->mySort();

 for (int i = 0;i<=aCards -> aCount ;i++) {
       if ( (my = (TCard *)aCards->At(i))!=NULL ) {
         my -> DrawCard(aPanel->Left+j*delatx,aPanel->Top + 10,visible);
          j++;
       }
 }
}
#endif
//-----------------------------------------------------------------------


