
#ifdef __BORLANDC__
 #include <Classes.hpp>
 #include <Controls.hpp>
 #include <StdCtrls.hpp>
 #include <Forms.hpp>
 #include <Menus.hpp>
 #include <ExtCtrls.hpp>
#endif

//-------------------------------------------------------------------------
#ifndef PLAYER_H
#define PLAYER_H

#include "card.h"
#include "cardlist.h"
#include "locale.h"
#include "ncounter.h"

#define RIGHT      1
#define LEFT       0
#define NOSIDE     3

//-------------------------------------------------------------------------
class TPlayer {
  public:
    TPlayer();
    ~TPlayer();
    TCardList *aCards; // 
    TCardList *aLeft;  //    (  )
    TCardList *aRight; //   (  )
    TCardList *aOut;   //  (  )
    TCardList *aCardsOut; //   
    TCardList *aLeftOut;  //      (  )
    TCardList *aRightOut; //     (  )

//    TMoveNode *MoveTree;

    int mymast; // 
    int flmizer; //     
    int vz;     //    
    int pere;   // 
    int vzmyvist; //     
    int vzmiser;  //   
    int typegame; //    GAME..MISER
    int enemy; // RIGHT or LEFT
    int currvz;
    int nPlayer; //  
    int mast4r[5]; //   
    int vzat4r[5]; // 
    int pere4r[5]; // 
    void maxgame4vist(Tgamestype EnemyGamesType,Tgamestype HaveOtherVist); //    
    void makeout(int nPlayerFirstMove); //    
    void maxgame(int nPlayerFirstMove); // ,  

    void makestatfill(void);   //  ""      
    TCard *makemove(TCard *lMove,TCard *rMove); //
    void CleanAll(void);
    Tgamestype nTorg(Tgamestype nMaxg,int _nPlayer,int nPlayerFirstMove);
    Tgamestype SayGame(Tgamestype );
    void printcards(void);
    int dept;
    #ifdef __BORLANDC__
      TPanel *aPanel;
      void DrawCards(int );
    #endif

private:
//----------------------------------------------------------------
// miser & raspass part
    void Recount4miser(int nPlFirstMove,TPlayer *LeftPlayer,TPlayer *RightPlayer,int nState); 
    /* nState:  0- 10 card statfill , 1- 12 card start fill,2 - 10 card real rasklad*/
    void MakeTreeMove4miser(Tncounter plcounter ,TCardList **aPlCards,TCard *First,TCard *Second,int mast);
    void MakeTree4miser(int nPlFirstMove,TPlayer *LeftPlayer,TPlayer *RightPlayer,int nState);                               
//----------------------------------------------------------------
    int vzinmast4vist  (int _mast,int &nlocvz,int &nlocpere); // 
    int vzinmast4vist2 (int _mast,int &nlocvz,int &nlocpere); //   
    void maxgame4vist2(void); //       

    void maxgame2(void); //    
    int  vzinmast2(int _mast); //      
    int  vzinmast(int _mast); //   
    int morevz(TCardList *my,TCardList *en,int mast); //  vzinmast
    inline int ValidMove(TCard *first,TCard *acard); //    
    TCard *mygame3(TCard *lMove,TCard *rMove); //      
    TCard *mypassandvist3(TCard *lMove,TCard *rMove);//        
    TCard *mypassandvist3vs(TCard *lMove,TCard *rMove); //                 
    TCard *mygame3vs(TCard *lMove,TCard *rMove); //               

    TCard *mygame2(TCard *rMove);
    TCard *mypassandvist2(TCard *rMove);
    TCard *mypassandvist2vs(TCard *rMove);
    TCard *mygame2vs(TCard *rMove);

    TCard *mygame1(void);
    TCard *mypassandvist1(void);
    TCard *mygame1vs(void);

    void setmygame0(void);


    inline TCard *ismy(TCard *my,TCard *left,TCard *right,int koz);

    Tgamestype myLastgamestype;
};
#endif
