/***************************************************************************
                          resource.h  -  description
                             -------------------
    begin                : Mon Mar  6 14:43:31 EET 2000
    copyright            : (C) 2000 by Azarniy I.V.
    email                : azarniy@usa.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef RESOURCE_H
#define RESOURCE_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


///////////////////////////////////////////////////////////////////
// resource.h  -- contains macros used for commands


///////////////////////////////////////////////////////////////////
// COMMAND VALUES FOR MENUBAR AND TOOLBAR ENTRIES


///////////////////////////////////////////////////////////////////
// File-menu entries
#define ID_FILE_NEW                 10020
#define ID_FILE_OPEN                10030

#define ID_FILE_SAVE                10050
#define ID_FILE_SAVE_AS             10060
#define ID_FILE_CLOSE               10070

#define ID_FILE_PRINT               10080

#define ID_FILE_QUIT                10100


///////////////////////////////////////////////////////////////////
// Edit-menu entries
#define ID_EDIT_UNDO                11010
#define ID_EDIT_REDO                11020
#define ID_EDIT_COPY                11030
#define ID_EDIT_CUT                 11040
#define ID_EDIT_PASTE               11050
#define ID_EDIT_SELECT_ALL          11060


///////////////////////////////////////////////////////////////////
// View-menu entries                    
#define ID_VIEW_TOOLBAR             12010
#define ID_VIEW_STATUSBAR           12020
#define ID_VIEW_BOLLET		          	12030
#define ID_VIEW_PREFERENSES         12040
#define ID_SET_FONT				         12050
///////////////////////////////////////////////////////////////////
// Game-menu entries
#define ID_NEWSINGLEGAME						14001
#define ID_NEWMULTIGAMECREATE				14002
#define ID_NEWMULTIGAMECONNECT			14003
#define ID_NEWMULTIGAMEINET					14004
///////////////////////////////////////////////////////////////////
// Help-menu entries
#define ID_HELP_ABOUT               1002
#define ID_HELP_DOC               	1003
///////////////////////////////////////////////////////////////////
// General application values
#define IDS_APP_ABOUT               "Kpref\nVersion " VERSION \
                                    "\nhttp://kpref.boom.ru/ \n(w) 2000 by Azarniy I.V. e-mail: azarniy@usa.net \n      \n     :)"
#define IDS_STATUS_DEFAULT          "Ready."

#endif // RESOURCE_H
