//deskview.h
// all graphics function depend
#ifndef DESKVIEW_H
#define DESKVIEW_H

#include "prfconst.h"

#ifdef P4WIN
  #ifndef GraphicsHPP
  #include <graphics.hpp>
  #endif
#endif
#ifdef P4LIN
	#include <qstring.h>
	#include <qpopupmenu.h>
	#include <qmainwindow.h>
	#include <qaccel.h>
	#include <qmenubar.h>
	#include <qtoolbar.h>
	#include <qpixmap.h>
	#include <qtoolbutton.h>
	#include <qapp.h>
	#include <qstatusbar.h>
	#include <qwhatsthis.h>
	#include <qmsgbox.h>
	#include <qfiledialog.h>
	#include <qimage.h>
	#include <qpainter.h>
#endif

#include "card.h"


class TDeskView {
  public :
  int Event;
#ifdef P4WIN
  TDeskView(TCanvas *);
  TCanvas *Canvas;
#endif
#ifdef P4LIN
  TDeskView();
//  QPainter *Canvas;
	QPaintDevice *PaintDevice;
#endif

  int nSecondStartWait;
  int DesktopWidht,DesktopHeight;
  int CardWidht,CardHeight;
  int xBorder,yBorder;
  int xLen,yLen;
  int xDelta,yDelta;
  void SysDrawCard(TCard *,int x,int y,int visible,int border);
  void SysDrawCardPartialy(TCard *,int x,int y,int visible,int border,int x2);  
  void SysSayMessage(char *,int x,int y);
  void ClearScreen(void);
  void ClearBox(int,int,int,int);
  void mySleep(int seconds);
  void MessageBox(const char *,const char *);
  void ShowBlankPaper(int nBuletScore);
  void ShowGamerScore(int i,char *sb,char *sm,char *slv,char *srv,char *tv);
  //----------------------------- for THuman gamer
  TGamesType makemove(TGamesType lMove,TGamesType rMove);
//  void SysDrawBorder(int ,int,int,int);
  void StatusBar(const char *);
#ifdef P4WIN
  void AlterColor(Graphics::TBitmap *,TColor ,TColor );
#endif
#ifdef P4LIN
  void AlterColor(QImage &,QColor ,QColor );
  void drawRotatedText(QPainter *p,int x,int y,float angle,char *text);
#endif

};


#endif
