#include "locale.h"

int kozir;
Tgamestype aCurrGame;

#ifdef CODEPAGE1251
#pragma  warn -pin
TGameName GameName[] = {
undefined,"",
halfvist," ",
pass,"",
vist,"",
catchmiser," ",
pass,"",
g61," !",
g62," !",
g63," ",
g64," ",
g65,"  ",
g71," ",
g72," ",
g73," ",
g74," ",
g75,"  ",
g81," ",
g82," ",
g83," ",
g84," ",
g85,"  .",
g91,"9 ",
g92,"9 ",
g93,"9 ",
g94,"9 ",
g95,"9  .    .",
g96,"     !!!",
g101," ",
g102," ",
g103," ",
g104," ",
g105,"   !"
};
TGameName GameName2[] = {
undefined,"",
halfvist," ",
vist,"",
catchmiser,"",
pass,"",
g61," ",
g62," ",
g63," ",
g64," ",
g65,"  ",
g71," ",
g72," ",
g73," ",
g74," ",
g75,"  ",
g81," ",
g82," ",
g83," ",
g84," ",
g85,"  .",
g91,"9 ",
g92,"9 ",
g93,"9 ",
g94,"9 ",
g95,"9  .",
g96,"    ",
g101," ",
g102," ",
g103," ",
g104," ",
g105,"   !"
};
#pragma  warn +pin
#endif
//--------------------------------------------------------------------------
char *pcCameName(int nGame) {
   for (int i=0;i<=sizeof(GameName)/sizeof(TGameName);i++) {
      if (GameName[i].game == nGame) return GameName[i].name;
   }
   return "";
}
//--------------------------------------------------------------------------
char *pcCameName2(int nGame) {
   for (int i=0;i<=sizeof(GameName2)/sizeof(TGameName);i++) {
      if (GameName2[i].game == nGame) return GameName2[i].name;
   }
   return "";
}
//--------------------------------------------------------------------------
int nGetGameCard(Tgamestype gType) {
   if ( gType >=g71 && gType <= 75)   return 7;
   if ( gType >=g81 && gType <= 85)   return 8;
   if ( gType >=g91 && gType <= 95)   return 9;
   if ( gType ==g96)                  return 0;
   if ( gType >=g101 && gType <= 105) return 10;
   return 6;
}
//--------------------------------------------------------------------------
int nGetVistCard(Tgamestype gType) {
   if ( gType >=g71 && gType <= 75)   return 2;
   if ( gType >=g81 && gType <= 85)   return 1;
   if ( gType >=g91 && gType <= 95)   return 1;
   if ( gType ==g96)                  return 0;
   if ( gType >=g101 && gType <= 105) return 1;
   return 4;
}
//--------------------------------------------------------------------------
int nGetMinCard4Vist(Tgamestype gType) {
   if ( gType >=g71 && gType <= 75)   return 2;
   if ( gType >=g81 && gType <= 85)   return 1;
   if ( gType >=g91 && gType <= 95)   return 1;
   if ( gType ==g96)                  return 0;
   if ( gType >=g101 && gType <= 105) return 1;
   return 3;
}
//--------------------------------------------------------------------------
int nGetGamePrice(Tgamestype gType) {
   if ( gType >=g71 && gType <= 75)    return 4;
   if ( gType >=g81 && gType <= 85)    return 6;
   if ( gType >=g91 && gType <= 95)    return 8;
   if ( gType ==g96)                   return 10;
   if ( gType >=g101 && gType <= 105)  return 10;
   return 2;
}
//----------------------------------------------------------------------
/*int nPlayerTakeCards(TCard *p1,TCard *p2,TCard *p3,int koz) {
   int nRetVal=0;
   TCard *CardMax;
   if ( koz!=5 ) {  //          
          nRetVal = 1;
          CardMax = p1;
          if ( *p2 > *p1 || (p2->CMast == koz && p1->CMast != koz) )  {
             CardMax = p2;
             nRetVal = 2;
          }
          if ( *p3 > *CardMax || (p3->CMast == koz && CardMax->CMast != koz) )  {
             CardMax = p3;
             nRetVal = 3;
          }
   } else {
          nRetVal = 1;
          CardMax = p1;
          if ( *p2 > *p1 ) {
             CardMax = p2;
             nRetVal = 2;
          }
          if ( *p3 > *CardMax ) {
             CardMax = p3;
             nRetVal = 3;
          }
   }
   return nRetVal; //  
} */


