/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Mon Mar  6 14:43:31 EET 2000
    copyright            : (C) 2000 by Azarniy I.V.
    email                : azarniy@usa.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qapplication.h>
#include <qfont.h>
#include <kapp.h>

#include "prfconst.h"
#include "kpref.h"
#include "papplication.h"
#include "qtformtorg.h"

KApplication  *PQApplication;

int main(int argc, char *argv[]) {
	int RetVal;
  KApplication a(argc, argv);
	PQApplication =  &a ;
  a.setFont (QFont("helvetica", FONTSIZE));
  a.setStyle(WindowsStyle);
  InitGameNameFori18n();
  kpref=new Kpref();
  a.setMainWidget(kpref);
	Formtorg = new QTFormtorg( 0,"Formtorg");
	Formtorg -> hide();
	kpref ->init();
	kpref-> resize(QApplication::desktop()->width()-30,
		QApplication::desktop()->height()-100);
  kpref->show();
  RetVal = a.exec();
	delete Formtorg;
	return RetVal;
}

/*
// Compare2List4Max checks
	 TCardList *My = new TCardList(8);
	 TCardList *Enemy = new TCardList(8);	
	 TGamer *Gamer =  new TGamer(1);
	
 	 TMastTable LMT;
	 My -> Insert(new TCard(13,1) );
	 My -> Insert(new TCard(12,1) );
	 My -> Insert(new TCard(10,1) );	
	
	 Enemy-> Insert(new TCard(14,1) );
//	 Enemy-> Insert(new TCard(8,1) );
//	 Enemy-> Insert(new TCard(11,1) );	
	 LMT = Gamer->Compare2List4Max(My,Enemy);
	 printf("\n vz=%i perehvatov=%i len=%i sum=%i\n",LMT.vzatok,LMT.perehvatov,LMT.len,LMT.sum);
	 delete My;
	 delete Enemy;
	 delete Gamer;
	 return 1;*/
