/***************************************************************************
                          qtnewgameu.cpp  -  description
                             -------------------
    begin                : Mon Mar 27 2000
    copyright            : (C) 2000 by Azarniy I.V.
    email                : azarniy@usa.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "qtnewgameu.h"
#include <kapp.h>
#include <stdlib.h>

qtnewgameu::qtnewgameu(QWidget *parent, const char *name) : QDialog(parent,name,true){
	initDialog();
}

qtnewgameu::~qtnewgameu(){
}

void  qtnewgameu::initDialog(){
	char pfn[1024];
	strcpy(pfn,getenv("HOME"));
	strcat(pfn,"/protocol.kpref");
  this->resize(310,340);
  this->setMinimumSize(310,340);
  this->setMaximumSize(310,340);

	flProtocol = new QCheckBox(i18n("Protocol"),this,"Protocol");
  flProtocol ->setGeometry(40,250,100,10);
  	
	ProtocolFileName = new QLineEdit(this,"ProtocolFileName");
  ProtocolFileName -> setGeometry(40,270,260,20);
  ProtocolFileName -> setText( pfn );
	
  Ok= new QPushButton(this,"Ok");
  Ok->setGeometry(40,300,100,30);
  Ok->setMinimumSize(0,0);
  Ok->setText(i18n(""));

  Cancel= new QPushButton(this,"Cancel");
  Cancel->setGeometry(170,300,100,30);
  Cancel->setMinimumSize(0,0);
  Cancel->setText(i18n("Cancel"));

  QButtonGroup_1= new QButtonGroup(this,"NoName");
  QButtonGroup_1->setGeometry(10,150,290,90);
  QButtonGroup_1->setMinimumSize(0,0);
  QButtonGroup_1->setTitle(i18n(" Whist "));

  VistNonBr= new QRadioButton(QButtonGroup_1,"VistNonBr");
  VistNonBr->setGeometry(10,50,100,30);
  VistNonBr->setMinimumSize(0,0);
  VistNonBr->setText(i18n("Greedy"));
  VistNonBr->setChecked(true);

  VistBrother= new QRadioButton(QButtonGroup_1,"VistBrother");
  VistBrother->setGeometry(10,20,100,30);
  VistBrother->setMinimumSize(0,0);
  VistBrother->setText(i18n("Non greedy"));

  QButtonGroup_2= new QButtonGroup(this,"NoName");
  QButtonGroup_2->setGeometry(160,50,140,90);
  QButtonGroup_2->setMinimumSize(0,0);
  QButtonGroup_2->setTitle(i18n("Ten"));

  TenCheck= new QRadioButton(QButtonGroup_2,"TenCheck");
  TenCheck->setGeometry(10,20,120,30);
  TenCheck->setMinimumSize(0,0);
  TenCheck->setText(i18n("Checking"));
  TenCheck->setChecked(true);

  TenVist= new QRadioButton(QButtonGroup_2,"TenVist");
  TenVist->setGeometry(10,50,100,30);
  TenVist->setMinimumSize(0,0);
  TenVist->setText(i18n("Whisting"));

  QButtonGroup_3= new QButtonGroup(this,"NoName");
  QButtonGroup_3->setGeometry(10,50,140,90);
  QButtonGroup_3->setMinimumSize(0,0);
  QButtonGroup_3->setTitle(i18n("Six of spades"));

  NormalGame= new QRadioButton(QButtonGroup_3,"NormalGame");
  NormalGame->setGeometry(10,20,120,30);
  NormalGame->setMinimumSize(0,0);
  NormalGame->setText(i18n("Simple"));
  NormalGame->setChecked(true);

  StalingradGame= new QRadioButton(QButtonGroup_3,"StalingradGame");
  StalingradGame->setGeometry(10,50,120,30);
  StalingradGame->setMinimumSize(0,0);
  StalingradGame->setText(i18n("Stalingrad"));

  QSpinBox_2= new QSpinBox(this,"NoName");
  QSpinBox_2->setGeometry(200,10,100,30);
  QSpinBox_2->setMinimumSize(0,0);
  QSpinBox_2->setRange(0,99);
	QSpinBox_2->setValue(21);


  QLabel_1= new QLabel(this,"NoName");
  QLabel_1->setGeometry(10,10,100,30);
  QLabel_1->setMinimumSize(0,0);
  QLabel_1->setText(i18n("Pool size"));

  connect( Ok, SIGNAL(clicked()),this, SLOT(slotOkClick( )) );
  connect( Cancel, SIGNAL(clicked()),this, SLOT(slotCancelClick( )) );

}

void qtnewgameu::slotOkClick() { 	accept (); }

void qtnewgameu::slotCancelClick() { 	reject (); }


