/***************************************************************************
                          thosenet.cpp  -  description
                             -------------------
    begin                : Fri Jun 16 2000
    copyright            : (C) 2000 by Azarniy I.V.
    email                : azarniy@usa.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <string.h>
#include "netconst.h"
#include "thosenet.h"
#include "deskview.h"

#ifdef P4LIN
#include <kapp.h>
#include "kpref.h"
#endif

#ifdef P4WIN
#include <vcl.h>
#endif

//---------------------------------------------------
THoseNet::THoseNet(int _nGamer) :  TGamer (_nGamer){

}
//---------------------------------------------------
THoseNet::THoseNet(int _nGamer,TDeskView *_DeskView) : TGamer (_nGamer,_DeskView){

}
//--------------------------------------------------------
THoseNet::THoseNet(int _nGamer,TDeskView *_DeskView,int netdesk,int master) : TGamer (_nGamer,_DeskView) {
	strcpy(this->NikName,"hose");
	strcpy(this->NikPasswd,"hosepwd");	
	nNetworkDesk = netdesk;
	MasterNumber = master;
}
//--------------------------------------------------------
TGamesType THoseNet::makeout4game(void) { //    
	TGamesType RetVal;
	TCard *Card1,*Card2;	
	int c1,c2;
	char buff[MAXDATASIZE];
	memset(buff,0,MAXDATASIZE);
        #ifdef P4WIN
        DeskView->StatusBar("  ");
        #endif
  #ifdef P4LIN
  DeskView->StatusBar(i18n("Wait for game"));
  #endif		

//	printf("\nTHoseNet::makeout4game:%i gnum:%i  r:",nGamer,nNetworkGamer);
	read_from_socket(socket,buff,MAXDATASIZE,0); // int
//	printf("\n+++++++++++++++++++++THoseNet::makeout4game:%i gnum:%i  readed:%s",nGamer,nNetworkGamer,buff);
	sscanf(buff,"%i%i%i",&c1,&c2,(int *)&RetVal);
	Card1 = aCards-> Exist(c1);
	Card2 = aCards-> Exist(c2);
	aCards-> Remove (Card1);
	aCards-> Remove (Card2);
        aCardsOut -> Insert(Card1);
        aCardsOut -> Insert(Card2);
	GamesType = RetVal;
        #ifdef P4WIN
        DeskView->StatusBar(" ");
        #endif
  #ifdef P4LIN
  DeskView->StatusBar(i18n("Recive game"));
  #endif		

	return RetVal;
}
//--------------------------------------------------------
TGamesType THoseNet::makeout4miser(void) {
	return makeout4game();
}
//--------------------------------------------------------
TCard *THoseNet::makemove(TCard *lMove,TCard *rMove,TGamer *aLeftGamer,TGamer *aRightGamer) {
	TCard *RetVal=NULL;
	int c1;
	char buff[MAXDATASIZE];
	memset(buff,0,MAXDATASIZE);
        #ifdef P4WIN
        DeskView->StatusBar(" ");
        #endif
  #ifdef P4LIN
  DeskView->StatusBar(i18n("Wait for move"));
  #endif		

//	printf("\nnum:%i gnum:%i  r:",nGamer,nNetworkGamer);
	read_from_socket(socket,buff,MAXDATASIZE,0); // int
//	printf("\nTCard *THoseNet::makemove - read fron net:%s",buff);
	sscanf(buff,"%i",&c1);
	RetVal = aCards -> Exist(c1);
//	printf("\n%p",RetVal);
	if (RetVal) {
//		printf(" cname:%i cmast%i",RetVal->CName,RetVal->CMast);
	}
        aCards    -> Remove(RetVal);
        aCardsOut -> Insert(RetVal);
        #ifdef P4WIN
        DeskView->StatusBar(" ");
        #endif
  #ifdef P4LIN
  DeskView->StatusBar(i18n("Move ok"));
  #endif		

	return RetVal;
}
//--------------------------------------------------------
TGamesType THoseNet::makemove(TGamesType lMove,TGamesType rMove) { //  
	TGamesType RetVal;
	char buff[MAXDATASIZE];
	memset(buff,0,MAXDATASIZE);
//	printf("\nmakemove torg num:%i gnum:%i  r:",nGamer,nNetworkGamer);
        #ifdef P4WIN
        DeskView->StatusBar(" ");
        #endif
  #ifdef P4LIN
  DeskView->StatusBar(i18n("wait for move"));
  #endif		

	read_from_socket(socket,buff,MAXDATASIZE,0); // int
//	printf("\nmakemove torg num:%i gnum:%i  w:%s Ok",nGamer,nNetworkGamer,buff);
	sscanf(buff,"%i",(int *)&RetVal);
	GamesType = RetVal;
	return RetVal;

//	return makeout4game();
}
//--------------------------------------------------------
TGamesType THoseNet::makemove(TGamesType MaxGame,int HaveAVist,int nGamerVist) { //     -   
//	return makeout4game();
	TGamesType RetVal;
	char buff[MAXDATASIZE];
	memset(buff,0,MAXDATASIZE);
        #ifdef P4WIN
        DeskView->StatusBar(" ");
        #endif
  #ifdef P4LIN
  DeskView->StatusBar(i18n("Wait for move"));
  #endif		

	read_from_socket(socket,buff,MAXDATASIZE,0);
//	printf("\n!!!!!!!!!!!THoseNet::makeout4game:%i gnum:%i  readed:%s",nGamer,nNetworkGamer,buff);
	sscanf(buff,"%i",(int *)&RetVal);
	GamesType = RetVal;
	return RetVal;
}
//--------------------------------------------------------
int THoseNet::join(int req) {
//extern char servername[100];
//extern unsigned int serverport;
        #ifdef P4WIN
        DeskView->StatusBar("");
        #endif
  #ifdef P4LIN
  DeskView->StatusBar(i18n("Connecting"));
  #endif		


	if ( connecttoserver(servername,serverport) < 0 )
		return (-1);
	return 	connecttodesk(0); //    
}
//--------------------------------------------------------
int THoseNet::connecttodesk(int req) {
	char buff[MAXDATASIZE];

	memset(buff,0,MAXDATASIZE);
	read_from_socket(socket,buff,MAXDATASIZE,0); // 
	memset(buff,0,MAXDATASIZE);

	sprintf(buff,"%i %s %s %i\n",req,NikName,NikPasswd,nGamer);
	// ,  socket  
	write_to_socket(socket,buff,strlen(buff)); //       .
	memset(buff,0,MAXDATASIZE);
	sprintf(buff,"%i %i\n",nNetworkDesk,MasterNumber); //      
	write_to_socket(socket,buff,strlen(buff));
	//    
	return 1;
}