/***************************************************************************
                          thumannet.cpp  -  description
                             -------------------
    begin                : Thu Jun 15 2000
    copyright            : (C) 2000 by Azarniy I.V.
    email                : azarniy@usa.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <string.h>
#include "netconst.h"
#include "thumannet.h"
#include "deskview.h"
#ifdef P4LIN
#include <kapp.h>
#include "kpref.h"
#endif
#ifdef P4WIN
#include <vcl.h>
#endif


THumanNet::THumanNet(int gm) :   THuman(gm){

}
//--------------------------------------------------------
THumanNet::THumanNet(int gm, TDeskView *dv) : THuman(gm,dv) {
//	strcpy()
}
//--------------------------------------------------------
TGamesType THumanNet::makeout4game(void) { //    
	TCard *Card1,*Card2;
	char buff[MAXDATASIZE];
  #ifdef P4WIN
  DeskView->StatusBar(" ");
  #endif
  #ifdef P4LIN
  DeskView->StatusBar(i18n("Make Move"));
  #endif		
	TGamesType RetVal = THuman::makeout4game();
	memset(buff,0,MAXDATASIZE);
	// 2     
	Card1 = (TCard *)aCardsOut->At(0);
	Card2 = (TCard *)aCardsOut->At(1);
	sprintf(buff,"%i%i %i%i %i \n",Card1->CName,Card1->CMast,Card2->CName,Card2->CMast,RetVal);
//	printf("\n$$$$$$$$$$$$$$$$$$$$$$THumanNet::makeout4gamenum:%i gnum:%i  w:%s",nGamer,nNetworkGamer,buff);
	write_to_socket(socket,buff,strlen(buff));
//	printf("\nTHumanNet::makeout4gamenum:%i gnum:%i  Ok",nGamer,nNetworkGamer);
	return RetVal;
}
//--------------------------------------------------------
TGamesType THumanNet::makeout4miser(void) {
	TGamesType RetVal = makeout4game();
	return RetVal;
}
//--------------------------------------------------------
TCard *THumanNet::makemove(TCard *lMove,TCard *rMove,TGamer *aLeftGamer,TGamer *aRightGamer) {
        #ifdef P4WIN
        DeskView->StatusBar(" ");
        #endif
  #ifdef P4LIN
  DeskView->StatusBar(i18n("Make Move"));
  #endif		

	TCard *RetVal = THuman::makemove(lMove,rMove,aLeftGamer,aRightGamer);
	char buff[MAXDATASIZE];
	memset(buff,0,MAXDATASIZE);
	sprintf(buff,"%i%i \n",RetVal->CName,RetVal->CMast);
	write_to_socket(socket,buff,strlen(buff));
//	printf("\nnum:%i gnum:%i  Ok",nGamer,nNetworkGamer);
	return RetVal;
}
//--------------------------------------------------------
TGamesType THumanNet::makemove(TGamesType lMove,TGamesType rMove) { //  

	TGamesType RetVal = THuman::makemove(lMove,rMove);

	char buff[MAXDATASIZE];
	memset(buff,0,MAXDATASIZE);
	sprintf(buff,"%i\n",RetVal);
//	printf("\nnum:%i gnum:%i  w:%s",nGamer,nNetworkGamer,buff);
	write_to_socket(socket,buff,strlen(buff));
//	printf("\nnum:%i gnum:%i  Ok",nGamer,nNetworkGamer);
	return RetVal;

//	TGamesType RetVal = makeout4game();
//	return RetVal;
}
//--------------------------------------------------------
TGamesType THumanNet::makemove(TGamesType MaxGame,int HaveAVist,int nGamerVist) { //     -   
        #ifdef P4WIN
        DeskView->StatusBar("   ?");
        #endif
  #ifdef P4LIN
  DeskView->StatusBar(i18n("Make Move"));
  #endif		

	TGamesType RetVal = THuman::makemove(MaxGame,HaveAVist,nGamerVist);
	char buff[MAXDATASIZE];
	memset(buff,0,MAXDATASIZE);
	sprintf(buff,"%i\n",RetVal);
//	printf("\nTHumanNet::makemoveaftertorg:%i gnum:%i  w:%s",nGamer,nNetworkGamer,buff);
	write_to_socket(socket,buff,strlen(buff));
//	printf("\nTHumanNet::makemoveaftertorg:%i gnum:%i  Ok",nGamer,nNetworkGamer);
	return RetVal;
}
//--------------------------------------------------------
int THumanNet::join(int req) {
	int rv;
        #ifdef P4WIN
        DeskView->StatusBar("  ");
        #endif
  #ifdef P4LIN
  DeskView->StatusBar(i18n("Connect to game server"));
  #endif		

	if ( connecttoserver(servername,serverport) < 0 )
		return (-1);
        #ifdef P4WIN
        DeskView->StatusBar("  ");
        #endif
  #ifdef P4LIN
  DeskView->StatusBar(i18n("Connect to desktop on game server"));
  #endif		
	rv = connecttodesk(req);
  #ifdef P4LIN
  DeskView->StatusBar(i18n("Connected"));
  #endif		
  #ifdef P4WIN
  DeskView->StatusBar("Connected");
  #endif
	
	return 	rv;
}
//--------------------------------------------------------
int THumanNet::connecttodesk(int req) {
	char buff[MAXDATASIZE];
	memset(buff,0,MAXDATASIZE);
	read_from_socket(socket,buff,MAXDATASIZE,0); // 
	memset(buff,0,MAXDATASIZE);
	sprintf(buff,"%i %s %s %i\n",req,NikName,NikPasswd,nGamer);
	// ,  socket  
	write_to_socket(socket,buff,strlen(buff)); //       .
	memset(buff,0,MAXDATASIZE);
	read_from_socket(socket,buff,MAXDATASIZE,0); //        
//	sscanf(buff,"%i%i",&nNetworkDesk,&nNetworkGamer);
//	memset(buff,0,MAXDATASIZE);
//	read_from_socket(socket,buff,MAXDATASIZE); //   4    
	if (! req) {
		sscanf(buff,"%i%i%i%i%i%i",&nNetworkDesk,&nNetworkGamer,&nBuletScore,&g61stalingrad,&g10vist,&globvist);
	} else {
		sscanf(buff,"%i%i",&nNetworkDesk,&nNetworkGamer);
		memset(buff,0,MAXDATASIZE);
		sprintf(buff,"%i %i %i %i\n",nBuletScore,g61stalingrad,g10vist,globvist);	//   
		write_to_socket(socket,buff,strlen(buff));	 //   
	}
	return 1;
}
//--------------------------------------------------------
int THumanNet::SendnPlayerTakeCards(int who) {
	int rv=who;
	char buff[MAXDATASIZE];
	memset(buff,0,MAXDATASIZE);
	if (nNetworkGamer == 1) {
		sprintf(buff,"%i \n",who)	;
		write_to_socket(socket,buff,strlen(buff));
	} else {
		read_from_socket(socket,buff,MAXDATASIZE,0);
		sscanf(buff,"%i",&rv);
		// rv - view point from 1 gamer on net desktop....translate
		if (nNetworkGamer==2) {
			switch (rv) {
				case 1: rv = 3; break;
				case 2: rv = 1; break;
				case 3: rv = 2; break;
			}
		}
		if (nNetworkGamer==3) {
			switch (rv) {
				case 1: rv = 2; break;
				case 2: rv = 3; break;
				case 3: rv = 1; break;
			}
		}
	}
	return rv;
}
//--------------------------------------------------------