//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdlib.h>
#include <shellapi.h>
#include <winbase.h>
#pragma hdrstop

#include "wp32.h"
#include "desktop.h"
#include "deskview.h"
#include "NewGameu.h"
#include "Aboutu.h"
#include "prfconst.h"
#include "netconst.h"
#include "Formtorg_u.h"
#include "NetFormu.h"
#include "kprefserverwin_u.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
   nAllReadyHinting = WaitingForMouseUp = 0;
   flthread = 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::New1Click(TObject *Sender)
{
    TNewGame *NewGame = new TNewGame(this);
    StatusBar1 -> SimpleText = "   ";
    NewGame -> ShowModal();
    if ( NewGame -> ModalResult == mrOk ) {
        if (DeskTop) {
            delete DeskTop;
            delete DeskView;
            DeskView = new TDeskView(Canvas);
            DeskTop = new TDeskTop();
            DeskTop -> DeskView = DeskView;
            nBuletScore = StrToInt(NewGame -> Edit1 -> Text);
            g61stalingrad = NewGame -> g61stalingrad -> ItemIndex;
            g10vist = NewGame -> g10vist -> ItemIndex;
            globvist = NewGame -> globvist -> ItemIndex;
            DeskTop -> DeskView = DeskView;
            Formtorg -> EnableAll();

            FormPaint(Sender);
            miSaveGame -> Enabled = true;
            if ( NewGame -> flProtocol -> Checked == true ) {
                    strcpy(DeskTop -> ProtocolFileName,NewGame -> ProtocolFileName->Text.c_str());
                    DeskTop -> flProtocol = 1;
                    DeskTop -> OpenProtocol();
            }
            delete NewGame;

        }
        DeskTop -> NetGame = 0;
        StatusBar1 -> SimpleText = "";

        DeskTop -> RunGame();
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormPaint(TObject *Sender)
{
    int x,y;
    if ( DeskView ) {
        DeskView -> DesktopHeight = ClientHeight;
        DeskView -> DesktopWidht = ClientWidth;
        DeskView->ClearScreen();
    }
//    this -> Invalidate();
//    this -> Update();
    if ( DeskTop ) {
        DeskTop -> Repaint();
    }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
    if (flthread) {
        kprefserverwinthread -> Terminate();
        delete kprefserverwinthread;
    }
    delete DeskTop;
    delete DeskView;
    DeskTop = NULL;
    DeskView = NULL;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
    Caption = "";
    Color = clGreen;
    DeskView = new TDeskView(Canvas);
    DeskTop = new TDeskTop();
    DeskTop -> DeskView = DeskView;

//    DeskTop->Canvas = Canvas;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
    exit(0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClick(TObject *Sender)
{
    DeskView -> Event = 1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormKeyPress(TObject *Sender, char &Key)
{
    FormClick(Sender);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Bollet1Click(TObject *Sender)
{
    StatusBar1 -> SimpleText = "";
    DeskTop->CloseBullet();
    DeskTop-> nflShowPaper = 1;
    DeskTop->ShowPaper();
    DeskTop->DeskView->mySleep(0);
    DeskView ->ClearScreen();
    DeskTop-> nflShowPaper = 0;
    DeskTop->Repaint();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
    WaitingForMouseUp = 1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormMouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
//    if (WaitingForMouseUp) {
//        TGamer *Gamer = (TGamer *) DeskTop -> Gamers->At(1);
        TGamer *Gamer = (TGamer *) DeskTop -> Gamers->At(DeskTop ->nCurrentMove.nValue);
        if (Gamer) {
                Gamer ->DeskView = DeskView;
                Gamer -> X = X;
                Gamer -> Y = Y;
        }
        WaitingForMouseUp = 0;
//    }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
//    if ( ! nAllReadyHinting ) {
        nAllReadyHinting = 1;
//        TGamer *Gamer = (TGamer *) DeskTop -> Gamers->At(1);
        TGamer *Gamer = (TGamer *) DeskTop -> Gamers->At(DeskTop ->nCurrentMove.nValue);
//        Gamer ->DeskView = DeskView;
		if (Gamer)   Gamer -> HintCard(X,Y);
        nAllReadyHinting = 0;
//    }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::miOpenGameClick(TObject *Sender)
{
    StatusBar1 -> SimpleText = " ";
    if ( OpenDialog1 -> Execute()) {
//        DeskTop -> RunGame();
/*        delete DeskTop;
        delete DeskView;
        DeskView = new TDeskView(Canvas);
        DeskTop = new TDeskTop();
        DeskTop -> DeskView = DeskView;*/
        DeskTop->LoadGame( OpenDialog1->FileName.c_str() );
        miSaveGame -> Enabled = true;
        StatusBar1 -> SimpleText = "";
        DeskTop->RunGame();
    }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::miSaveGameClick(TObject *Sender)
{
    StatusBar1 -> SimpleText = " ";
    if ( DeskTop  && SaveDialog1 -> Execute()) {
        DeskTop->SaveGame( SaveDialog1->FileName.c_str() );
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::AboutClick(TObject *Sender)
{
    StatusBar1 -> SimpleText = " ";
    AboutBox  = new TAboutBox (this);
    AboutBox -> ShowModal();
    delete AboutBox;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Font1Click(TObject *Sender)
{
    StatusBar1 -> SimpleText = " ";
    FontDialog1 = new TFontDialog(this);
    if (FontDialog1->Execute())
        this ->Font = FontDialog1->Font;
    delete  FontDialog1;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::N4Click(TObject *Sender)
{
    ShellExecute(Application->MainForm->Handle,NULL,"kprefrules.html",NULL, NULL,SW_SHOW );
}
//---------------------------------------------------------------------------

void __fastcall TForm1::NewNetClick(TObject *Sender)
{
    char *kprefservername="localhost";
//    kprefserverwin *kprefserverwinthread;
//    char buff[sizeof(WSADATA)+ WSADESCRIPTION_LEN+WSASYS_STATUS_LEN+2];
    StatusBar1 -> SimpleText = "  ";
    if ( ! initnetinmustdie() ) {
           StatusBar1 -> SimpleText = " !       WinSock !    !";
           DeskView -> MessageBox("\n\n Cant init winsock. \n\n","Fatal network error !");
           return ;
    }
  //  sprintf(buff,"wVersion:%i wHighVersion:%i\nszDescription:%s szSystemStatus:%s\niMaxSockets:%i iMaxUdpDg:%i\n lpVendorInfo:%s",wsaData.wVersion,wsaData.wHighVersion,wsaData.szDescription,wsaData.szSystemStatus,wsaData.iMaxSockets,wsaData.iMaxUdpDg,wsaData.lpVendorInfo==NULL?"May be Microsoft":wsaData.lpVendorInfo);
//        DeskView -> MessageBox(buff,"NetInform");

    NetForm = new TNetForm(this);
    NetForm -> Proxy -> Enabled = false;
    NetForm -> ProxyPort -> Enabled = false;
    NetForm -> desks -> Enabled = false;
//    NetForm -> qservername->Text = "localhost";
    NetForm -> qservername->Text = kprefservername ;

    NetForm -> qservername-> Enabled = true;
    NetForm -> Connect-> Enabled = false;
    NetForm -> NewNetServer-> Enabled = true;
    StatusBar1 -> SimpleText = "   ,      ";
    NetForm -> ShowModal();
    strcpy(servername,NetForm ->qservername->Text.c_str() );
    serverport = atoi(NetForm ->qport->Text.c_str() ) ;
    strcpy(nikname,NetForm ->qnikname->Text.c_str() );
    strcpy(passwd,NetForm ->qpasswd->Text.c_str() );
    if (!DeskTop ->ValidateNikAndPassword()) {
                cleannetinmustdie();
                return ;
    }
    if (NetForm->ModalResult == mrOk) {
	if ( !strcmp (kprefservername,servername) ) {
                StatusBar1 -> SimpleText = "  ";
		port = serverport;
	        kprefserverwinthread = new kprefserverwin(false);
                flthread = 1;
        }
//        Sleep(500);
        TNewGame *NewGame = new TNewGame(this);
        StatusBar1 -> SimpleText = "  ";
        NewGame -> ShowModal();
        if ( NewGame -> ModalResult == mrOk ) {
            if (DeskTop) {
                delete DeskTop;
                delete DeskView;
                DeskView = new TDeskView(Canvas);
                DeskTop = new TDeskTop();
                DeskTop -> DeskView = DeskView;
                nBuletScore = StrToInt(NewGame -> Edit1 -> Text);
                g61stalingrad = NewGame -> g61stalingrad -> ItemIndex;
                g10vist = NewGame -> g10vist -> ItemIndex;
                globvist = NewGame -> globvist -> ItemIndex;
                DeskTop -> DeskView = DeskView;
                Formtorg -> EnableAll();
                FormPaint(Sender);
                miSaveGame -> Enabled = true;
                delete NewGame;
                Cursor = crHourGlass;

		if ( !DeskTop -> MakeNewNetGame() ) {
                    delete kprefserverwinthread;
                    cleannetinmustdie();
                    Cursor = crDefault;
                    return;
                }
                Cursor = crDefault;
                StatusBar1 -> SimpleText = "  !   !";
                DeskTop -> PrepareNetGame();
                DeskTop -> GetNikNames();
                NewNet->Enabled = false;
                NewINet->Enabled = false;
                StatusBar1 -> SimpleText = "  ";
                DeskTop -> RunGame();
                cleannetinmustdie();
                delete NetForm;
                NewNet->Enabled = true;
                NewINet->Enabled = false;
            }
        }
        flthread = 0;
        delete kprefserverwinthread;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
//        FormDestroy(Sender);
    exit(0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCloseQuery(TObject *Sender, bool &CanClose)
{
        CanClose = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::NewNetConnectClick(TObject *Sender)
{
    StatusBar1 -> SimpleText = "  ";
    if ( ! initnetinmustdie() ) {
           StatusBar1 -> SimpleText = " !      TCP/IP";
           DeskView -> MessageBox("\n\n Cant init winsock. \n\n","Fatal network error !");
           return ;
    }

    NetForm = new TNetForm(this);
    NetForm -> Proxy -> Enabled = false;
    NetForm -> ProxyPort -> Enabled = false;
    NetForm -> desks -> Enabled = false;
    NetForm -> qservername->Text = "computer.domain.com";
    NetForm -> qservername-> Enabled = true;
    NetForm -> Connect-> Enabled = true;
    NetForm -> NewNetServer-> Enabled = false;
    StatusBar1 -> SimpleText = "  ,  ,     ";
    NetForm -> ShowModal();
    if (NetForm->ModalResult == mrYes) {
        strcpy(servername,NetForm ->qservername->Text.c_str() );
        serverport = atoi(NetForm ->qport->Text.c_str() ) ;
        strcpy(nikname,NetForm ->qnikname->Text.c_str() );
        strcpy(passwd,NetForm ->qpasswd->Text.c_str() );
        if (!DeskTop ->ValidateNikAndPassword()) {
                cleannetinmustdie();
                return ;
        }
        Cursor = crHourGlass;
        StatusBar1 -> SimpleText = " ";
	if ( !DeskTop -> JoinToNetGame() ) {
                StatusBar1 -> SimpleText = "     ";
                cleannetinmustdie();
                Cursor = crDefault;
		return;
	}
//	fileMenu->setItemEnabled(nSaveGameID,TRUE);
        StatusBar1 -> SimpleText = " !";
	DeskTop -> PrepareNetGame();
	DeskTop -> GetNikNames();
        Cursor = crDefault;
        StatusBar1 -> SimpleText = "  ";
	DeskTop -> RunGame();
//	fileMenu->setItemEnabled(nSaveGameID,FALSE);

    }
    delete NetForm;
    cleannetinmustdie();
}
//---------------------------------------------------------------------------

